SystemOrganization addCategory: #'Ma-Collections-Collections'!
SystemOrganization addCategory: #'Ma-Collections-Dictionarys'!
SystemOrganization addCategory: #'Ma-Collections-Dictionarys-Auto'!
SystemOrganization addCategory: #'Ma-Collections-Dictionarys-Auto-Tests'!
SystemOrganization addCategory: #'Ma-Collections-Exceptions'!
SystemOrganization addCategory: #'Ma-Collections-Info'!
SystemOrganization addCategory: #'Ma-Collections-Numbers collections'!
SystemOrganization addCategory: #'Ma-Collections-Records'!
SystemOrganization addCategory: #'Ma-Collections-Sets'!
SystemOrganization addCategory: #'Ma-Collections-private'!
SystemOrganization addCategory: #'Ma-Collections-Tests'!
SystemOrganization addCategory: #'Ma-Collections-Tree'!

!Dictionary methodsFor: '*ma-collections' stamp: 'cmm 10/19/2010 22:07'!
finalizeValues
	"For API compatibility with Weak-Dictionary's.  There have been cases where a pluggable Dictionary may be weak or strong."! !

Dictionary subclass: #MaDictionary
	instanceVariableNames: ''
	classVariableNames: 'Primes'
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaDictionary commentStamp: '<historical>' prior: 0!
| sd md r | 
Transcript clear.
r := OrderedCollection new.
ByteString allInstancesDo: [:each | r add: each ].
Smalltalk garbageCollect.
sd := Dictionary new.
Transcript cr; show: 'time to add all strings to sd: ', 
	[ r do: [:each | sd at: each put: each ] ] timeToRun printString.
Smalltalk garbageCollect.
sd := MaDictionary new.
Transcript cr; show: 'time to add all strings to md: ', 
	[ r do: [:each | sd at: each put: each ] ] timeToRun printString.


r _ (1 to: 15500) collect: [ :e | Object new ].
r _ r shuffled.
Smalltalk garbageCollect.
sd _ WeakIdentityKeyDictionary new.
md _ MaWeakIdentityKeyDictionary new.
Transcript cr; show: 'time to add to sd: ', ([ r do: [ :each | sd at: each put: each ] ] timeToRun) printString.
Transcript cr; show: 'time to add to md: ', ([ r do: [ :each | md at: each put: each ] ] timeToRun) printString.
r_r shuffled.
Transcript cr; show: 'time to access to sd: ', ([ r do: [ :each | sd at: each ] ] timeToRun) printString.
Transcript cr; show: 'time to access to md: ', ([ r do: [ :each | md at: each ] ] timeToRun) printString.
r _ r shuffled.
Transcript cr; show: 'time to replace to sd: ', ([ r do: [ :each | sd at: each put: each ] ] timeToRun) printString.
Transcript cr; show: 'time to replace to md: ', ([ r do: [ :each | md at: each put: each ] ] timeToRun) printString.
r _ r shuffled.
Transcript cr; show: 'time to remove 300 from sd: ', ([ (r copyFrom: 1 to: 300) do: [ :each | sd removeKey: each ] ] timeToRun) printString.
Transcript cr; show: 'time to remove 300 from md: ', ([ (r copyFrom: 1 to: 300) do: [ :each | md removeKey: each ] ] timeToRun) printString.
!

MaDictionary subclass: #MaAutoWeakDictionary
	instanceVariableNames: 'list preInitializedAssoc'
	classVariableNames: 'IsSupported'
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoWeakDictionary commentStamp: 'Igor.Stasenko 5/12/2010 19:07' prior: 0!
I am a basic class for dictionaries which holding either keys or values weakly.
I can auto-clean myself after garbage collection.

I am using a special kind of associations , which appropriate for fast cleanup.
I am not removing an existing association objects physically, but rather marking them as empty,
so they can be reused later, when you want to add some more key/value pairs!

MaAutoWeakDictionary subclass: #MaAutoIdentityKeyWeakValueDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoIdentityKeyWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 22:42'!
associationClass
	^ MaAutoIdentityKeyWeakValueAssociation! !

!MaAutoIdentityKeyWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 22:44'!
keyHash: key
	^ (key identityHash \\ array size) + 1! !

!MaAutoIdentityKeyWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 07:58'!
keyHash: key size: aSize
	^ (key identityHash \\ aSize) + 1! !

!MaAutoWeakDictionary class methodsFor: 'testing' stamp: 'cmm 7/18/2010 19:43'!
determineIfSupported
	"Answer whether this image can support auto-cleaning weak dictionary's.  This requires Igor's finalization enhancement produced in Q1/2010."
	| weakFinalizationListClass weakFinalizerItem list item |
	weakFinalizationListClass := Smalltalk classNamed: #WeakFinalizationList.
	weakFinalizerItem := Smalltalk classNamed: #WeakFinalizerItem.
	weakFinalizationListClass ifNil: [ ^ false ].
	weakFinalizerItem ifNil: [ ^ false ].
	list := weakFinalizationListClass new.
	item := (Smalltalk classNamed: #WeakFinalizerItem) new
		list: list
		object: Object new
		executor: nil.
	list first isNil ifFalse: [ ^ false ].
	item object notNil ifFalse: [ ^ false ].
	Smalltalk garbageCollect.
	item object isNil ifFalse: [ ^ false ].
	list first == item ifFalse: [ ^ false ].
	list first next == nil ifFalse: [ ^ false ].
	^ true! !

!MaAutoWeakDictionary class methodsFor: 'initialize-release' stamp: 'cmm 6/14/2010 22:15'!
initialize
	super initialize.
	Smalltalk addToStartUpList: self! !

!MaAutoWeakDictionary class methodsFor: 'testing' stamp: 'cmm 6/14/2010 22:26'!
isAutoCleaning
	"Type-check.  Answer whether I am an auto-cleaning type of Dictionary.  Makers of instances may need to check their instances on startup.."
	^ true! !

!MaAutoWeakDictionary class methodsFor: 'initialize-release' stamp: 'cmm 6/14/2010 22:16'!
startUp: resuming
	"Reset the IsSupported bit because we don't know whether this VM supports it or not."
	IsSupported := nil! !

!MaAutoWeakDictionary class methodsFor: 'testing' stamp: 'cmm 6/14/2010 22:24'!
supportsAutoCleaning
	"Answer whether this image can support auto-cleaning weak dictionary's.  This requires Igor's finalization enhancement produced in Q1/2010."
	^ IsSupported ifNil: [ IsSupported := self determineIfSupported ]! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 22:30'!
associationAt: key ifAbsent: aBlock 
	
	^ (array at: (self keyHash:key)) maFindKey: key ifAbsent: aBlock
! !

!MaAutoWeakDictionary methodsFor: 'enumerating' stamp: 'Igor.Stasenko 11/8/2010 00:05'!
associationsDo: aBlock
	self finalizeValues. "make sure we're clean before iterating"
	array do: [ :b |
		b ifNotNil: [ b do: aBlock ]
	].
! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 18:33'!
at: key
	| index asc |
	index := self keyHash: key.
	asc := (array at: index) maFindKey: key.
	(asc isNil or: [ asc isFree ]) ifTrue: [ ^ self errorKeyNotFound: key ].
	^ asc value! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 18:32'!
at: key ifAbsent: aBlock
	| index asc |
	index := self keyHash: key.
	asc := (array at: index) maFindKey: key.
	(asc isNil or: [ asc isFree ]) ifTrue: [ ^ aBlock value ].
	^ asc value! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 18:37'!
at: key ifAbsentPut: aBlock
	| index asc val |
	index := self keyHash: key.
	
	asc := (array at: index) maFindKey: key.
	
	asc ifNil: [ ^ self atIndex: index insertKey: key value: aBlock value ].
	asc isFree ifFalse: [ ^ asc value ].

	val := aBlock value.
	asc
		finList: list; 
		key: key; 
		value: val.
	tally := tally +1.
	self checkForOverflow.
	^ val
! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 18:28'!
at: key put: value
	| index asc |
	index := self keyHash: key.
	
	asc := (array at: index) maFindKey: key.
	asc ifNil: [ ^ self atIndex: index insertKey: key value: value ].
	asc isFree ifFalse: [ asc value: value. ^ value ].

	" fill the free association "	
	asc
		finList: list; 
		key: key; 
		value: value.
	tally := tally +1.
	self checkForOverflow.
	^ value
! !

!MaAutoWeakDictionary methodsFor: 'private' stamp: 'Igor.Stasenko 9/24/2010 17:33'!
atIndex: index insertKey: key value: value
	| newb |
	newb := preInitializedAssoc shallowCopy key: key value: value next: (array at: index).
	array at: index put: newb.
	tally := tally + 1.
	self checkForOverflow.
	^ value

	! !

!MaAutoWeakDictionary methodsFor: 'finalization' stamp: 'Igor.Stasenko 5/12/2010 23:59'!
finalizeValues
	
	| asc |
	
	asc := list swapWithNil.
	[ asc notNil ] whileTrue: [ | next |
		next := asc finNext.
		asc clear.
		tally := tally - 1.
		asc := next.
	].

! !

!MaAutoWeakDictionary methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 17:30'!
initialize

	super initialize.
	list := WeakFinalizationList new.
	preInitializedAssoc := self associationClass new finList: list.! !

!MaAutoWeakDictionary methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 17:39'!
initialize: sz

	super initialize: sz.
	list := WeakFinalizationList new.
	preInitializedAssoc := self associationClass new finList: list.! !

!MaAutoWeakDictionary methodsFor: 'private' stamp: 'Igor.Stasenko 5/12/2010 22:00'!
rehash: newSize
	| newArray index |
	"rehash"
	newArray := Array new: newSize.
	array do: [ :b | | next |
		next := b.
		[ next notNil ] whileTrue: [  | nn |
			nn := next next.
			"skip over free associations"
			next isFree ifFalse: [
				index := self keyHash: next key size: newSize.
				next next: (newArray at: index).
				newArray at: index put: next.
			].
			next := nn]
	].
	array := newArray.! !

!MaAutoWeakDictionary methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 22:18'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| bucket val |
	
	bucket := (array at: (self keyHash: key)) maFindKey: key ifAbsent: [ ^ aBlock value ].
	"we're not deleting the association, just clearing it out"
	val := bucket value.
	bucket clear.
	tally := tally - 1. 
	self checkForUnderflow.
	^ val
! !

MaAutoWeakDictionary subclass: #MaAutoWeakKeyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

MaAutoWeakKeyDictionary subclass: #MaAutoWeakIdentityKeyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:16'!
associationClass
	^ MaAutoWeakIdentityKeyAssociation! !

!MaAutoWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 22:44'!
keyHash: key
	^ (key identityHash \\ array size) + 1! !

!MaAutoWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/13/2010 07:55'!
keyHash: key size: aSize
	^ (key identityHash \\ aSize) + 1! !

!MaAutoWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:00'!
associationClass
	^ MaAutoWeakKeyAssociation! !

!MaAutoWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 19:26'!
finalizeValues
	
	| asc |
	
	self class supportsAutoCleaning ifFalse: [
		"do the hard way, scan whole dictionary"
		array do: [:e |
			asc := e.
			[ asc notNil ] whileTrue: [ | next |
				next := asc next.
				asc key ifNil: [ asc clear. tally := tally - 1 ].
				asc := next ]
		].
		^ self.
	].

	asc := list swapWithNil.
	[ asc notNil ] whileTrue: [ | next |
		next := asc finNext.
		asc clear.
		tally := tally - 1.
		asc := next.
	].

! !

!MaAutoWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 11/8/2010 00:33'!
includesKey: aKey
	aKey ifNil: [ ^ false ].
	^ super includesKey: aKey! !

MaAutoWeakDictionary subclass: #MaAutoWeakValueDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:15'!
associationClass
	^MaAutoWeakValueAssociation! !

!MaDictionary class methodsFor: 'as yet unclassified' stamp: 'sig 7/19/2007 22:26'!
initialize
	"Primes up to 2^27"
	Primes := #(
		5 5 11 17 37 67 131 257 521 1031 2053 4099 8209 16411 32771 65537 131101 
		262147 524309 1048583 2097169 4194319 8388617 16777259 33554467 67108879 134217757).
! !

!MaDictionary class methodsFor: 'as yet unclassified' stamp: 'sig 7/19/2007 22:26'!
primes
	^ Primes! !

!MaDictionary methodsFor: 'adding' stamp: 'sig 7/19/2007 22:26'!
add: anAssociation
	self at: anAssociation key put: anAssociation value.
	^ anAssociation! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/20/2007 16:03'!
associationAt: key ifAbsent: aBlock 
	| bucket |
	bucket := array at: (self keyHash:key).
	^ bucket ifNil: aBlock
		ifNotNil: [ (bucket findKeyOrNil: key) ifNil: aBlock ]! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/20/2007 12:37'!
associationClass
	^ MaAssociation! !

!MaDictionary methodsFor: 'enumerating' stamp: 'Igor.Stasenko 11/8/2010 00:05'!
associationsDo: aBlock
	array do: [ :b |
		b ifNotNil: [ b do: aBlock ]
	].
! !

!MaDictionary methodsFor: 'accessing' stamp: 'sig 7/20/2007 14:22'!
at: key ifAbsent: aBlock
	| bucket |
	bucket := array at: (self keyHash: key).
	[bucket notNil] whileTrue: [ bucket key = key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ aBlock value.
! !

!MaDictionary methodsFor: 'accessing' stamp: 'sig 7/20/2007 15:56'!
at: key ifAbsentPut: aBlock
	| index bucket |
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key = key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: aBlock value.
! !

!MaDictionary methodsFor: 'accessing' stamp: 'cmm 10/30/2011 16:49'!
at: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock 
	^ oneArgBlock value:
		(self
			at: anObject
			ifAbsent: [ ^ zeroArgBlock value ])! !

!MaDictionary methodsFor: 'accessing' stamp: 'sig 7/20/2007 15:23'!
at: key put: value
	| index bucket  |
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key = key ifTrue: [ bucket value: value. ^ value ]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: value.

! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
atIndex: index insertKey: key value: value
	| newb |
	newb := self associationClass key: key value: value next: (array at: index).
	array at: index put: newb.
	tally := tally + 1.
	self checkForOverflow.
	^ value

	! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
atRandom: aGenerator
	"Its ugly slow, not recommended to use."
	| ind i |
	self emptyCheck.
	ind := aGenerator nextInt: array size.
	i := 1.
	self associationsDo: [:b |  (i=ind) ifTrue: [^b]. i := i +1].

	self errorEmptyCollection.! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
bestArraySizeFor: size
	| hb |
	hb := size highBit. 
	^ (hb <= Primes size) ifTrue: [ Primes at: hb ] ifFalse: [ size ]! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/20/2007 12:25'!
checkForOverflow
	| sz |
	sz := array size.
	( sz < self maxBuckets) ifTrue: [
		tally >= (sz * 4) ifTrue: [ self rehash: (self bestArraySizeFor: tally * 2). ]
	]
	! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
checkForUnderflow
	tally < (array size / 4) ifTrue: [ self rehash: (self bestArraySizeFor: tally * 2 +1). ]
	! !

!MaDictionary methodsFor: 'copying' stamp: 'sig 7/25/2007 18:20'!
copy
	| dict |
	dict := self species new: self size.
	self associationsDo: [:b | dict at: b key put: b value  ].
	^ dict.! !

!MaDictionary methodsFor: 'enumerating' stamp: 'sig 7/19/2007 22:26'!
do: aBlock
	self associationsDo: [:assoc | aBlock value: assoc value]! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/25/2007 17:46'!
grow
	"do nothing"! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
keyHash: key
	^ (key hash \\ array size) + 1! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
keyHash: key size: aSize
	^ (key hash \\ aSize) + 1! !

!MaDictionary methodsFor: 'accessing' stamp: 'sig 7/19/2007 22:29'!
maAllKeysAtValue: anObject

	| aCollection |
	aCollection := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | value = anObject ifTrue: [ aCollection add: key ] ].
	^aCollection
! !

!MaDictionary methodsFor: 'testing' stamp: 'sig 7/19/2007 22:30'!
maIsHashedCollection

	^true
! !

!MaDictionary methodsFor: 'private' stamp: 'cmm 3/28/2010 11:51'!
maxBuckets
	^ SmallInteger maxVal! !

!MaDictionary methodsFor: 'private' stamp: 'Igor.Stasenko 9/24/2010 17:34'!
rehash
	
	"Force rehashing .. (was do nothing)"
	
	self rehash: array size! !

!MaDictionary methodsFor: 'private' stamp: 'sig 7/19/2007 22:26'!
rehash: newSize
	| newArray index |
	"rehash"
	newArray := Array new: newSize.
	array do: [ :b | | next |
		next := b.
		[ next notNil ] whileTrue: [  | nn |
			nn := next next.
			index := self keyHash: next key size: newSize.
			next next: (newArray at: index).
			newArray at: index put: next.
			next := nn]
	].
	array := newArray.! !

!MaDictionary methodsFor: 'removing' stamp: 'sig 7/19/2007 22:26'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index bucket next |
	index := self keyHash: key.
	bucket := array at: index.
	bucket ifNil: [ ^ aBlock value ].
	bucket key = key ifTrue: [ 
		tally := tally -1. 
		array at: index put: bucket next. 
		self checkForUnderflow.
		^ bucket value ].
	[(next := bucket next) notNil ] whileTrue: [
		next key = key ifTrue: [ 
		tally := tally - 1. 
		bucket next: next next. 
		self checkForUnderflow.
		^ next value ].
		bucket := next.
	].
	^ aBlock value! !

!MaDictionary methodsFor: 'accessing' stamp: 'sig 7/19/2007 22:26'!
size
	^ tally! !

MaDictionary subclass: #MaIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:39'!
associationClass
	^ MaIdentityKeyAssociation ! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:36'!
at: key ifAbsent: aBlock
	| bucket |
	bucket := array at: (self keyHash: key).
	[bucket notNil] whileTrue: [ bucket key == key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ aBlock value.
! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 3/27/2010 22:30'!
at: key ifAbsentPut: aBlock
	| index bucket |
	index := self keyHash: key.
	bucket := array at: index.
	[bucket ~~ nil] whileTrue: [ bucket key == key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: aBlock value.
! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:35'!
at: key put: value
	| index bucket  |
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key == key ifTrue: [ bucket value: value. ^ value ]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: value.

! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 14:59'!
keyHash: key
	^ (key identityHash \\ array size) + 1! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 14:59'!
keyHash: key size: aSize
	^ (key identityHash \\ aSize) + 1! !

!MaIdentityDictionary methodsFor: 'private' stamp: 'cmm 3/28/2010 11:50'!
maxBuckets 
	"squeak uses 12 bits for identity hash, using buckets more than 2^12 is pointless"
	^ 4096 " 2 raisedTo: 12 "

! !

!MaIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:43'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index bucket next |
	index := self keyHash: key.
	bucket := array at: index.
	bucket ifNil: [ ^ aBlock value ].
	bucket key == key ifTrue: [ 
		tally := tally -1. 
		array at: index put: bucket next. 
		self checkForUnderflow.
		^ bucket value ].
	[(next := bucket next) notNil ] whileTrue: [
		next key == key ifTrue: [ 
		tally := tally - 1. 
		bucket next: next next. 
		self checkForUnderflow.
		^ next value ].
		bucket := next.
	].
	^ aBlock value! !

MaIdentityDictionary subclass: #MaIdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Sets'!

!MaIdentitySet methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:45'!
add: anObject 
	^ self 
		at: anObject
		put: nil! !

!MaIdentitySet methodsFor: 'as yet unclassified' stamp: 'cmm 1/19/2012 20:17'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the resulting values into a collection that is like me. Answer with the new collection."
	| newCollection |
	newCollection := self species new: self size.
	self associationsDo:
		[ : each | newCollection add: (aBlock value: each key) ].
	^ newCollection! !

!MaIdentitySet methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:45'!
do: aBlock
	self keysDo: aBlock! !

!MaIdentitySet methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:45'!
includes: anObject
	^ self includesKey: anObject! !

!MaIdentitySet methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:48'!
remove: anObject ifAbsent: aBlock 
	^ self 
		removeKey: anObject
		ifAbsent: aBlock! !

MaDictionary subclass: #MaWeakKeyDictionary
	instanceVariableNames: 'lastClean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

MaWeakKeyDictionary subclass: #MaWeakIdentityKeyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:39'!
associationClass
	^ MaWeakIdentityKeyAssociation! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/25/2007 17:56'!
at: key ifAbsent: aBlock
	| bucket |
	"nil keys always absent in weak dictionary"
	key ifNil: [ ^ aBlock value ] ifNotNil: [
		bucket := array at: (self keyHash: key).
		[bucket notNil] whileTrue: [ bucket key == key ifTrue: [^ bucket value]. bucket := bucket next ].
		^ aBlock value.
	]
! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 16:09'!
at: key ifAbsentPut: aBlock
	| index bucket |
	key ifNil: [ ^ aBlock value ].	"nil keys is not allowed"
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key == key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: aBlock value.
! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 16:09'!
at: key put: value
	| index bucket  |
	key ifNil: [ ^ value ].	"nil keys is not allowed"
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key == key ifTrue: [ bucket value: value. ^ value ]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: value.
! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/19/2007 22:28'!
keyHash: key
	^ (key identityHash \\ array size) + 1! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/19/2007 22:28'!
keyHash: key size: aSize
	^ (key identityHash \\ aSize) + 1! !

!MaWeakIdentityKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/25/2007 18:01'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index bucket next |
	key ifNil: [ ^ aBlock value ].
	index := self keyHash: key.
	bucket := array at: index.
	bucket ifNil: [ ^ aBlock value ].
	bucket key == key ifTrue: [ 
		tally := tally -1. 
		array at: index put: bucket next. 
		self checkForUnderflow.
		^ bucket value ].
	[(next := bucket next) notNil ] whileTrue: [
		next key == key ifTrue: [ 
		tally := tally - 1. 
		bucket next: next next. 
		self checkForUnderflow.
		^ next value ].
		bucket := next.
	].
	^ aBlock value! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:38'!
associationClass
	^ MaWeakKeyAssociation 

	! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/25/2007 17:54'!
at: key ifAbsent: aBlock
	| bucket |
	"nil keys always absent in weak dictionary"
	key ifNil: [ ^ aBlock value ] ifNotNil: [
		bucket := array at: (self keyHash: key).
		[bucket notNil] whileTrue: [ bucket key = key ifTrue: [^ bucket value]. bucket := bucket next ].
		^ aBlock value.
	]
! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 16:00'!
at: key ifAbsentPut: aBlock
	| index bucket |
	key ifNil: [ ^ aBlock value ].	"nil keys is not allowed"
	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key = key ifTrue: [^ bucket value]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: aBlock value.! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 15:54'!
at: key put: value
	| index bucket  |
	"its better to use some Dead unique object for determining dead weaklings,
	but since in squeak dead weaklings replaced by nil, we can't allow to add it as key"
	key ifNil: [ ^ value ].	"nil keys is not allowed"

	index := self keyHash: key.
	bucket := array at: index.
	[bucket notNil] whileTrue: [ bucket key = key ifTrue: [ bucket value: value. ^ value ]. bucket := bucket next ].
	^ self atIndex: index insertKey: key value: value.

! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 10/19/2010 21:16'!
finalizeValues
	"This can be expensive, only do it if it has been a while."
	self isTimeToClean ifTrue: 
		[ self primFinalizeValues.
		self resetLastClean ]! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 10/19/2010 21:16'!
finalizeValues: finiObjects
	"Remove all associations with key == nil and value is in finiObjects.  This method is folded with #rehash for efficiency."

	"sig: this message sent only from WeakRegistry, and there is always key==nil for each finiObjects,
	no point to do anything extra than simple finalizeValues
	"
	^ self finalizeValues! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 5/16/2010 22:09'!
initialize: anObject 
	super initialize: anObject.
	self resetLastClean! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 10/11/2011 21:27'!
isTimeToClean
	"Due to inefficient finalization, limit the frequency of cleaning."
	^ (Time millisecondsSince: self lastClean) > 30000! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/27/2007 00:04'!
keysDo: aBlock 
	"Evaluate aBlock for each of the receiver's keys."
	self associationsDo: [:association | 
		association key ifNotNil:[aBlock value: association key]].! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 5/16/2010 22:06'!
lastClean
	^ lastClean ifNil: [ lastClean := 0 ]! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 10/19/2010 22:51'!
primFinalizeValues
	"remove all nil keys and rehash the receiver afterwards"
	1 to: array size do: [:i | | each next |
		each := array at: i.
		[ each notNil and: [ each key isNil] ] whileTrue: [ tally:= tally -1. each := each next].
		array at: i put: each.
		each ifNotNil: [
			next := each next.
			[ next notNil ] whileTrue: [ next key ifNil: [ tally := tally -1. each next: next next ] ifNotNil: [ each := next ]. next := next next ].
		]
	]! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/25/2007 18:02'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index bucket next |
	key ifNil: [ ^ aBlock value ].
	index := self keyHash: key.
	bucket := array at: index.
	bucket ifNil: [ ^ aBlock value ].
	bucket key = key ifTrue: [ 
		tally := tally -1. 
		array at: index put: bucket next. 
		self checkForUnderflow.
		^ bucket value ].
	[(next := bucket next) notNil ] whileTrue: [
		next key = key ifTrue: [ 
		tally := tally - 1. 
		bucket next: next next. 
		self checkForUnderflow.
		^ next value ].
		bucket := next.
	].
	^ aBlock value! !

!MaWeakKeyDictionary methodsFor: 'as yet unclassified' stamp: 'cmm 5/16/2010 19:37'!
resetLastClean
	lastClean := Time millisecondClockValue! !

MaDictionary subclass: #MaWeakValueDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:38'!
associationClass
	^ MaWeakValueAssociation! !

!MaWeakValueDictionary methodsFor: 'as yet unclassified' stamp: 'sig 9/3/2007 15:38'!
reject: aBlock
" dirty hack , uncomment following line
	10 seconds asDelay wait. "
	^ super reject: aBlock! !

!UndefinedObject methodsFor: '*ma-collections' stamp: 'Igor.Stasenko 9/24/2010 18:27'!
maFindKey: key
	" ^ self == nil "! !

!UndefinedObject methodsFor: '*ma-collections' stamp: 'Igor.Stasenko 5/12/2010 22:15'!
maFindKey: key ifAbsent: aBlock
	^ aBlock value! !

!UndefinedObject methodsFor: '*ma-collections' stamp: 'Igor.Stasenko 5/12/2010 22:12'!
maFindKey: key ifAbsent: aBlock ifFree: aBlockFree
	^ aBlock value! !

MaSoftwareError subclass: #MaSpecialCollectionsSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Exceptions'!

PackageInfo subclass: #MaSpecialCollectionsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Info'!

!MaSpecialCollectionsPackageInfo class methodsFor: 'overriding' stamp: 'cmm 4/21/2011 16:45'!
initialize
	^ self new register! !

!MaSpecialCollectionsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 5/24/2010 16:34'!
readmeText

	^'I provide several independent, special-purpose collection classes that seem to be generally useful.

MaWeakIdentityKeyDictionary and MaWeakValueDictionary wrap a collection of their Smalltalk counterparts and keeps them all under 12-bits in size, thus minimizing the number of collisions due to Squeaks 12-bits identity hash.  These provide major improvement in the #removeKey: message.

MaTree is one of my first attempts at a Smalltalk collection.  I never actually used it though I decided to keep it around.  It''s API compatible with the other collections.  To play with an example:

	MaTree new
		add: ''Great Grandma'';
		add: ''Grandma'' asChildOf: ''Great Grandma'';
		add: ''Mom'' asChildOf: ''Grandma'';
		yourself


MaIntervalCollection is can efficiently track interval ranges and merge them when they get within their proximityThreshold.  This is useful for recording occupied space in a memory map, or perhaps grouping entities based on their proximity to each other.  Example:

	(MaIntervalCollection proximityThreshold: 1)
		addFrom: 5 to: 10;
		addFrom: 15 to: 20;
		addFrom: 25 to: 30;
		addFrom: 21 to: 24;
		yourself


MaLargeArrayOfNumbers is an auto-growing, never-shrinking array of numbers.  All numbers have the same number of bits available to represent them.  It maintains the collection in a single randomly-accessed file, and is therefore constrained by available disk space or the addressability of the file.

	MaLargeArrayOfNumbers create: filenameString bitSize: 32.
	myArray _ MaLargeArrayOfNumbers open: filenameString.
	myArray
		at: 10 put: 8734 ;
		at: 11 put: 6199 ;
		yourself
	"be sure to #close it when you are done."


MaHashIndex is another file-based, large-collection of uniformly-sized numbers.  It is much slower but more flexible than MaLargeArrayOfNumbers.  It allows pages between any two key ranges via:

	#upTo: countInteger keysAndValuesFrom: lowKey to: highKey startingAt: index

and pages between any two absolute positions via:

	#upTo: countInteger keysAndValuesFromIndex: lowIndex

Other features are:
	- supports key and value sizes from 16 to 256 bits
	- supports duplicate keys
	- includes test cases that demonstrate its capability and correctness

	MaHashIndex 
		create: fileNameString 
		keySize: 64 
		hashRecordSize: 10.
	myIndex := MaHashIndex open: filenameString.
	myIndex
		add: 8734 at: 10 ;
		add: 1212 at: 10 ;  "duplicate key ok"
		add: 6199 at: 11 ;
		yourself.
	"be sure to #close it when you are done."
'! !

!Collection class methodsFor: '*ma-collections' stamp: 'cmm 6/15/2010 14:02'!
isAutoCleaning
	"Answers whether this type of collection is an auto-cleaning type of collection.  Distinct from #supportsAutoCleaning."
	^ false! !

!Collection class methodsFor: '*ma-collections' stamp: 'cmm 6/15/2010 14:02'!
supportsAutoCleaning
	"supportsAutoCleaning is different from #isAutoCleaning.  It answers whether, even if I am a type of collection that is auto-cleaning, a newer vm is required to suport that, and so this answers whether it is also supported."
	^ false! !

MaUserError subclass: #MaHashIndexUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Exceptions'!

Association subclass: #MaAssociation
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaAssociation class methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:32'!
key: key value: value next: next
	^ self basicNew key: key value: value next: next! !

!MaAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:32'!
do: aBlock
	aBlock value: self.
	next ifNotNil: [ next do: aBlock ]! !

!MaAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:32'!
findKeyOrNil: akey
	^ key = akey ifTrue: [ self ] ifFalse: [ next ifNotNil: [next findKeyOrNil: akey ] ]! !

!MaAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:32'!
key: akey value: avalue next: anext
	key := akey.
	value := avalue.
	next := anext! !

!MaAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:32'!
next
	^ next! !

!MaAssociation methodsFor: 'accessing' stamp: 'sig 7/20/2007 12:32'!
next: aNext
	next := aNext! !

MaAssociation subclass: #MaIdentityKeyAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaIdentityKeyAssociation methodsFor: 'as yet unclassified' stamp: 'cmm 6/22/2009 13:39'!
findKeyOrNil: akey
	^ key == akey ifTrue: [ self ] ifFalse: [ next ifNotNil: [next findKeyOrNil: akey ] ]! !

MaAssociation subclass: #MaWeakKeyAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

MaWeakKeyAssociation subclass: #MaWeakIdentityKeyAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaWeakIdentityKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:33'!
findKeyOrNil: akey
	^ self key == akey ifTrue: [ self ] ifFalse: [ next ifNotNil: [next findKeyOrNil: akey ] ]! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
< aLookupKey 
	"Refer to the comment in Magnitude|<."

	^self key < aLookupKey key! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
= aLookupKey

	self species = aLookupKey species
		ifTrue: [^self key = aLookupKey key]
		ifFalse: [^false]! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'cmm 11/5/2008 17:05'!
do: aBlock 
	| k |
	k := self key.
	k ifNotNil: [ aBlock value: self ].
	next ifNotNil: [ next do: aBlock ]! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
findKeyOrNil: akey
	^ self key = akey ifTrue: [ self ] ifFalse: [ next ifNotNil: [next findKeyOrNil: akey ] ]! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
hash
	"Hash is reimplemented because = is implemented."

	^self key hash! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
hashMappedBy: map
	"Answer what my hash would be if oops changed according to map."

	^self key hashMappedBy: map! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
identityHashMappedBy: map
	"Answer what my hash would be if oops changed according to map."

	^ self key identityHashMappedBy: map! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
key
	^key ifNotNil: [key at: 1]! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
key: aKey
	key := WeakArray with: aKey! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
key: aKey value: anObject
	key := WeakArray with: aKey.
	value := anObject.! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
key: aKey value: anObject next: aNext
	key := WeakArray with: aKey.
	value := anObject.
	next := aNext! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
printOn: aStream
	self key printOn: aStream.
	aStream nextPutAll: '->'.
	self value printOn: aStream! !

!MaWeakKeyAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:34'!
storeOn: aStream
	aStream 
		nextPut: $(;
		nextPutAll: self class name;
		nextPutAll:' key: '.
	self key storeOn: aStream.
	aStream nextPutAll: ' value: '.
	self value storeOn: aStream.
	aStream nextPut: $)! !

Object subclass: #MaDictionaryBencher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto-Tests'!

!MaDictionaryBencher class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 19:08'!
benchAllOperations: collectionSize


	^ #( At AtIfAbsent AtIfAbsentPut AtPut AtIfAbsentPut2 ) collect: [:op |
		
		op -> (self benchKnownClasses: op size: collectionSize)
		]
! !

!MaDictionaryBencher class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 19:08'!
benchKnownClasses: operation size: collectionSize
	| sel |
	
	sel := ('bench' , operation, ':size:') asSymbol.
	
	^ self knownClasses collect: [:cls |
			cls name -> (self new perform: sel withArguments: { cls. collectionSize })
		]

! !

!MaDictionaryBencher class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 19:02'!
knownClasses

^ { Dictionary. WeakKeyDictionary. WeakIdentityKeyDictionary. WeakValueDictionary.
 MaDictionary. MaWeakKeyDictionary. MaWeakIdentityKeyDictionary. MaWeakValueDictionary.
 MaAutoWeakKeyDictionary. MaAutoWeakIdentityKeyDictionary. MaAutoWeakValueDictionary. MaAutoIdentityKeyWeakValueDictionary } ! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:51'!
benchAt: aDictClass size: aCollectionSize

	| coll dict time shuffled |
	
	coll := self createCollectionOfSize: aCollectionSize.
	dict := aDictClass new.
	coll do: [:each | dict at: each put: each ].
	
	time := OrderedCollection new.
	10 timesRepeat: [
		shuffled := coll shuffled.
		Smalltalk garbageCollect.
		time add: [ 
			shuffled do: [:each | dict at: each] ] timeToRun
	].

	^ time average asFloat
	
! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:58'!
benchAtIfAbsent: aDictClass size: aCollectionSize

	" in this benchmark, we making a half of keys present,
	while another half absent. 
	so, an absent block will be evaluated 50% of time"
	
	| coll coll2 dict time shuffled count |

	coll := self createCollectionOfSize: aCollectionSize.
	coll2 := (coll first: (aCollectionSize // 2)) asOrderedCollection addAll: (self createCollectionOfSize: aCollectionSize //2 ).
	
	time := OrderedCollection new.
	10 timesRepeat: [
		count := 0. 
		dict := aDictClass new.
		shuffled := coll2 shuffled.
		Smalltalk garbageCollect.
		coll do: [:e | dict at: e put: e].
		time add: [ shuffled do: [:each | dict at: each ifAbsent: [ count := count +1 ] ] ] timeToRun
	].		

	^ time average asFloat! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:46'!
benchAtIfAbsentPut2: aDictClass size: aCollectionSize

	" in this benchmark, we making a half of elements existing,
	while another half not,
	so, ifAbsentPut evaluating a block 50% of time"
	
	| coll coll2 dict time shuffled |
	coll := self createCollectionOfSize: aCollectionSize.
	coll2 := (coll first: (aCollectionSize // 2)) asOrderedCollection addAll: (self createCollectionOfSize: aCollectionSize //2 ).
	
	time := OrderedCollection new.
	10 timesRepeat: [
		dict := aDictClass new.
		shuffled := coll2 shuffled.
		Smalltalk garbageCollect.
		coll do: [:e | dict at: e put: e].
		time add: [ shuffled do: [:each | dict at: each ifAbsentPut: [ each ] ] ] timeToRun
	].		

	^ time average asFloat! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:38'!
benchAtIfAbsentPut: aDictClass size: aCollectionSize

	| coll dict time shuffled |
	coll := self createCollectionOfSize: aCollectionSize.
	time := OrderedCollection new.
	10 timesRepeat: [
		dict := aDictClass new.
		shuffled := coll shuffled.
		Smalltalk garbageCollect.
		time add: [ shuffled do: [:each | dict at: each ifAbsentPut: [ each ] ] ] timeToRun
	].		

	^ time average asFloat! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:49'!
benchAtPut: aDictClass size: aCollectionSize

	| coll dict time shuffled |
	coll := self createCollectionOfSize: aCollectionSize.
	time := OrderedCollection new.
	10 timesRepeat: [
		dict := aDictClass new.
		shuffled := coll shuffled.
		Smalltalk garbageCollect.
		time add: [ shuffled do: [:each | dict at: each put: each ] ] timeToRun
	].		

	^ time average asFloat! !

!MaDictionaryBencher methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 18:04'!
createCollectionOfSize: aSize
	
	^ ((1 to: aSize) collect: [:e | Object new ]) 
! !

Object weakSubclass: #MaWeakAssociation
	instanceVariableNames: 'finList finNext next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaWeakAssociation commentStamp: 'Igor.Stasenko 5/12/2010 21:02' prior: 0!
I am an abstact basic class for associations which holding either key or value weakly!

MaWeakAssociation weakSubclass: #MaAutoWeakKeyAssociation
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

MaAutoWeakKeyAssociation weakSubclass: #MaAutoWeakIdentityKeyAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoWeakIdentityKeyAssociation methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:03'!
compareKey: aKey
	"answer true if my key matching given aKey"
	^ (self basicAt: 1) == aKey! !

!MaAutoWeakKeyAssociation methodsFor: 'comparing and hashing' stamp: 'Igor.Stasenko 5/12/2010 20:44'!
compareKey: aKey
	"answer true if my key matching given aKey"
	^ (self basicAt: 1) = aKey! !

!MaAutoWeakKeyAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:53'!
key
	^ self basicAt: 1! !

!MaAutoWeakKeyAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:44'!
key: aKey
	self basicAt: 1 put: aKey! !

!MaAutoWeakKeyAssociation methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 17:32'!
key: key value: aValue next: aNext

	self basicAt: 1 put: key.
	value := aValue.
	next := aNext! !

!MaAutoWeakKeyAssociation methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/12/2010 18:50'!
key: key value: aValue next: aNext finList: aList

	self basicAt: 1 put: key.
	value := aValue.
	finList := aList.
	next := aNext! !

!MaAutoWeakKeyAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:53'!
value
	^ value! !

!MaAutoWeakKeyAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:43'!
value: aValue
	value := aValue! !

MaWeakAssociation weakSubclass: #MaAutoWeakValueAssociation
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

MaAutoWeakValueAssociation weakSubclass: #MaAutoIdentityKeyWeakValueAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto'!

!MaAutoIdentityKeyWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 22:41'!
compareKey: aKey
	"answer true if my key matching given aKey"
	^ key == aKey! !

!MaAutoWeakValueAssociation methodsFor: 'comparing and hashing' stamp: 'Igor.Stasenko 5/12/2010 21:13'!
compareKey: aKey
	"answer true if my key matching given aKey"
	^ key = aKey! !

!MaAutoWeakValueAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 21:13'!
key
	^ key! !

!MaAutoWeakValueAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 21:13'!
key: aKey
	key := aKey! !

!MaAutoWeakValueAssociation methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 17:32'!
key: aKey value: aValue next: aNext
	key := aKey.
	self basicAt: 1 put: aValue.
	next := aNext! !

!MaAutoWeakValueAssociation methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/12/2010 21:12'!
key: aKey value: aValue next: aNext finList: aList

	key := aKey.
	self basicAt: 1 put: aValue.
	finList := aList.
	next := aNext! !

!MaAutoWeakValueAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 21:12'!
value
	^ self basicAt: 1! !

!MaAutoWeakValueAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 21:13'!
value: anObject
	self basicAt: 1 put: anObject! !

!MaWeakAssociation class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 18:56'!
key: key value: value next: next finList: aList
	^ (self basicNew: 1) key: key value: value next: next finList: aList! !

!MaWeakAssociation class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 18:48'!
new
	^ self basicNew: 1! !

!MaWeakAssociation methodsFor: 'comparing and hashing' stamp: 'Igor.Stasenko 5/12/2010 20:48'!
= anObject
	"my instances should not be used in dictionaries as keys"
	^ self == anObject! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:55'!
clear

	finNext := finList := nil.
	self key: nil; value: nil! !

!MaWeakAssociation methodsFor: 'comparing and hashing' stamp: 'Igor.Stasenko 5/12/2010 20:39'!
compareKey: aKey
	"answer true if my key matching given aKey"
	self subclassResponsibility ! !

!MaWeakAssociation methodsFor: 'bucket iterations' stamp: 'Igor.Stasenko 5/12/2010 18:58'!
do: aBlock
	finList ifNotNil: [ aBlock value: self ].
	next ifNotNil: [ next do: aBlock ]! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:39'!
finList
	^ finList! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:39'!
finList: aList
	finList := aList! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 19:05'!
finNext
	^ finNext! !

!MaWeakAssociation methodsFor: 'comparing and hashing' stamp: 'Igor.Stasenko 5/12/2010 20:48'!
hash
	"my instances should not be used in dictionaries as keys"

	^ self identityHash! !

!MaWeakAssociation methodsFor: 'testing' stamp: 'Igor.Stasenko 5/12/2010 20:29'!
isFree
	^ finList == nil! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:52'!
key
	self subclassResponsibility ! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:40'!
key: aKey
	self subclassResponsibility ! !

!MaWeakAssociation methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/12/2010 18:49'!
key: key value: value next: next finList: aList
	self subclassResponsibility ! !

!MaWeakAssociation methodsFor: 'bucket iterations' stamp: 'Igor.Stasenko 11/8/2010 00:16'!
maFindKey: aKey 
	"find an association with given key,
	- answer nil, if key not found
	- answer free association if key not found and there is a free association found in list
	- if key found, answer it "
	| nxt free |	
	free := nil.
	nxt := self.
	[ nxt notNil ] whileTrue: [
		nxt isFree ifTrue: [ free := nxt ] ifFalse: [
			(nxt compareKey: aKey) ifTrue: [ ^ nxt ]
			].
		free ifNil: [ nxt := nxt next ] ifNotNil: [ nxt := nxt skipFree ].
	].
	^ free! !

!MaWeakAssociation methodsFor: 'bucket iterations' stamp: 'Igor.Stasenko 5/12/2010 22:16'!
maFindKey: aKey ifAbsent: aBlock
	"find an association with given key,
	or free association, found during scanning, or nil"
	| nxt |	
	nxt := self.
	[ nxt notNil ] whileTrue: [
		nxt finList ifNotNil: [ (nxt compareKey: aKey) ifTrue: [ ^ nxt ]].
		nxt := nxt next
	].
	^ aBlock value! !

!MaWeakAssociation methodsFor: 'bucket iterations' stamp: 'Igor.Stasenko 5/12/2010 22:13'!
maFindKey: aKey ifAbsent: aBlock ifFree: aBlockFree
	"find an association with given key,
	or free association, found during scanning, or nil"
	| nxt free |	
	free := nil.
	nxt := self.
	[ nxt notNil ] whileTrue: [
		nxt finList ifNil: [ free := nxt ] ifNotNil: [
			(nxt compareKey: aKey) ifTrue: [ ^ nxt ]
			].
		nxt := nxt next
	].
	^ free ifNil: aBlock ifNotNil: [ aBlockFree value: free ]! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:52'!
next
	^ next! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:52'!
next: aNext
	next := aNext! !

!MaWeakAssociation methodsFor: 'printing' stamp: 'Igor.Stasenko 5/12/2010 21:54'!
printOn: aStream

	self key printOn: aStream.
	aStream nextPutAll: '->'.
	self value printOn: aStream! !

!MaWeakAssociation methodsFor: 'bucket iterations' stamp: 'Igor.Stasenko 11/8/2010 00:10'!
skipFree
	| n |
	n := next.
	[ n notNil and: [ n isFree ] ] whileTrue: [ n := n next ].
	^ next := n.
	! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 18:52'!
value
	self subclassResponsibility ! !

!MaWeakAssociation methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/12/2010 20:40'!
value: anObject
	self subclassResponsibility ! !

!WeakIdentityKeyDictionary methodsFor: '*ma-collections' stamp: 'cmm 6/22/2009 16:57'!
asMaDictionary
	| answer |
	answer := MaWeakIdentityKeyDictionary new.
	self keysAndValuesDo: 
		[ : key : value | 
		answer 
			at: key
			put: value ].
	^ answer! !

MaObject subclass: #MaFixedLengthRecord
	instanceVariableNames: 'byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-private'!

!MaFixedLengthRecord class methodsFor: 'create' stamp: 'cmm 5/19/2005 11:05'!
new: anInteger

	^ self new
		byteArray: (ByteArray new: anInteger) ;
		yourself! !

!MaFixedLengthRecord methodsFor: 'accessing' stamp: 'cmm 5/19/2005 10:52'!
byteArray
	^ byteArray! !

!MaFixedLengthRecord methodsFor: 'accessing' stamp: 'cmm 5/19/2005 10:52'!
byteArray: aByteArray
	byteArray := aByteArray! !

MaFixedLengthRecord subclass: #MaHashIndexRecord
	instanceVariableNames: 'recordNumber lowKey highKey keySize valueSize numberOfSlots entrySize entryWeight canHoldDuplicateKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-private'!

!MaHashIndexRecord commentStamp: 'cmm 4/28/2005 21:25' prior: 0!
keySize and valueSize are specified in bits.
entrySize is in bytes.
!

!MaHashIndexRecord class methodsFor: 'creation' stamp: 'cmm 7/18/2005 13:22'!
keySize: keyBits valueSize: valueBits numberOfSlots: entrySizeInteger

	^ self new
		keySize: keyBits
		valueSize: valueBits
		numberOfSlots: entrySizeInteger ;

		postInitialize ;
		yourself! !

!MaHashIndexRecord methodsFor: 'SUnit tests' stamp: 'cmm 12/6/2002 00:05'!
addAnomaliesTo: aDictionary usingParent: parentRecord

	| originalCount |
	originalCount := aDictionary size.
	self
		addChildCountAnomaliesTo: aDictionary
		using: parentRecord.
	^aDictionary size > originalCount! !

!MaHashIndexRecord methodsFor: 'SUnit tests' stamp: 'cmm 12/6/2002 00:04'!
addChildCountAnomaliesTo: aDictionary using: parentRecord

	| bax parentNumberOfChildren isCorrect |
	bax := self baxInParent: parentRecord for: self.
	parentNumberOfChildren := (parentRecord numberOfChildrenAtByteArrayIndex: bax).
	isCorrect := (self lowKey = self highKey or: [ self numberOfChildren = 0 ])
		ifTrue: 
			[ "it's possible for the record not to have an entry in the parent under this condition."
			(parentRecord hasEntryAtByteArrayIndex: bax)
				ifTrue: [ (parentNumberOfChildren - 1) = self numberOfChildren ]
				ifFalse: [ parentNumberOfChildren = self numberOfChildren ] ]
		ifFalse:
			[ (parentNumberOfChildren - 1) = self numberOfChildren ].
	isCorrect ifFalse:
		[ (aDictionary
			at: 'number of children discrepency'
			ifAbsentPut: [ OrderedCollection new ]) add: { parentRecord.  self } ]! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
allNumberOfChildren
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self numberOfChildrenAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 9/1/2006 18:47'!
atKey: keyInteger put: valueInteger 
	"The receiver has been verified for some available slot for keyInteger."
	self 
		eligibleByteArrayIndexesFor: keyInteger
		reverseDo: 
			[ : index | 
			(self hasSlotAvailableAtByteArrayIndex: index) ifTrue: 
				[ self 
					keyAtByteArrayIndex: index
					put: keyInteger.
				self 
					valueAtByteArrayIndex: index
					put: valueInteger.
				self occupySlotAtByteArrayIndex: index.
				^ index ] ].
	MaSoftwareError signal: 'I should have been verified for an available slot.'! !

!MaHashIndexRecord methodsFor: 'SUnit tests' stamp: 'cmm 11/29/2002 23:39'!
baxInParent: parentRecord for: childRecord

	parentRecord
		byteArrayIndexesFrom: 0
		do:
			[ :bax |
			(parentRecord recordNumberAtByteArrayIndex: bax) = childRecord recordNumber
				ifTrue: [ ^bax ] ].
	self error: 'I am not child of parentRecord'! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 7/1/2005 17:00'!
baxMap

	| map |

	map := OrderedCollection new.
	self
		byteArrayIndexesFrom: 0
		do: [ :each | map add: (self slotIndexForBax: each) -> each ].
	^map asArray
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 11/27/2011 20:03'!
beFrom: lowKeyInteger to: highKeyInteger 
	self
		 lowKey: lowKeyInteger ;
		 highKey: highKeyInteger ;
		 resetForNewKeyRange! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 7/1/2005 17:09'!
beZoomedInToward: keyInteger from: aMaHashIndexRecord
	"Set the receivers low and highIndex to the correct range that can
	accomodate the index where keyInteger belongs in aMaHashIndexRecord."

	| index |

	index := aMaHashIndexRecord slotIndexFor: keyInteger.
	self
		beFrom: (aMaHashIndexRecord lowestKeyAtIndex: index)
		to: (aMaHashIndexRecord highestKeyAtIndex: index)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
bufferSize

	^byteArray size
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/22/2002 00:12'!
byteArrayIndexContainingGlobalIndex: anInteger base: baseInteger
	"baseInteger is 0-based."

	| count |

	count := baseInteger.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			count := count + (self numberOfChildrenAtByteArrayIndex: each).
			count >= anInteger ifTrue: [ ^each ] ].
	^nil! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
byteArrayIndexFor: entryIndex

	^entryIndex * entrySize + self headerSize
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/27/2002 14:55'!
byteArrayIndexOfLowestEntry
	"Answers nil if no entries on this record."

	self
		byteArrayIndexesFrom: 0
		do:
			[ :each | (self hasEntryAtByteArrayIndex: each) ifTrue: [ ^each ] ].
	^nil! !

!MaHashIndexRecord methodsFor: 'actions' stamp: 'cmm 7/1/2005 16:51'!
byteArrayIndexesFrom: startingEntryIndex do: oneArgBlock

	self
		byteArrayIndexesFrom: startingEntryIndex
		to: numberOfSlots - 1
		do: oneArgBlock! !

!MaHashIndexRecord methodsFor: 'actions' stamp: ''!
byteArrayIndexesFrom: startingEntryIndex to: endingEntryIndex do: oneArgBlock

	(self byteArrayIndexFor: startingEntryIndex)
		to: (self byteArrayIndexFor: endingEntryIndex)
		by: entrySize
		do: oneArgBlock
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
canAdd: keyInteger

	self
		eligibleByteArrayIndexesFor: keyInteger
		do: [ :index | (self hasSlotAvailableAtByteArrayIndex: index) ifTrue: [ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
canHoldDuplicateKeys

	^canHoldDuplicateKeys! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 9/1/2006 18:11'!
controlAtByteArrayIndex: anInteger
	^ byteArray 
		maUint: self sizeOfControlFieldInBits
		at: anInteger + self controlEntryOffset! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 9/1/2006 18:12'!
controlAtByteArrayIndex: index put: anInteger
	^ byteArray 
		maUint: self sizeOfControlFieldInBits
		at: index + self controlEntryOffset
		put: anInteger! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 8/30/2006 21:08'!
controlEntryOffset
	^ 0! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 9/10/2006 20:54'!
decrementNumberOfChildrenAtByteArrayIndex: anInteger
	| currentNumberOfChildren |
	currentNumberOfChildren := self numberOfChildrenAtByteArrayIndex: anInteger.
	currentNumberOfChildren = 0 ifTrue: [MaSoftwareError signal].
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren - 1! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 11/30/2002 23:51'!
decrementNumberOfChildrenAtKey: keyInteger

	self decrementNumberOfChildrenAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/9/2004 23:53'!
dumpEntries

	self dumpEntriesTo: Transcript! !

!MaHashIndexRecord methodsFor: 'printing' stamp: 'cmm 9/10/2006 00:36'!
dumpEntriesTo: aStream 
	self 
		byteArrayIndexesFrom: 0
		do: 
			[ : eachBax | 
			(self numberOfChildrenAtByteArrayIndex: eachBax) > 0 ifTrue: 
				[ | x |
				x := self slotIndexForBax: eachBax.
				aStream
					cr ;
					space ;
					space ;
					maPrint: 'x:' ;
					maPrint: x ;
					maPrint: ' [' ;
					maPrint: (self lowestKeyAtIndex: x) ;
					maPrint: '..' ;
					maPrint: (self highestKeyAtIndex: x) ;
					maPrint: ']' ;
					maPrint: ' bx:' ;
					maPrint: (self byteArrayIndexFor: x).
				(self hasSlotAvailableAtByteArrayIndex: eachBax) ifTrue: [ aStream nextPutAll: ' *empty slot* ' ].
				aStream
					maPrint: ' k:' ;
					maPrint: (self keyAtByteArrayIndex: eachBax) ;
					maPrint: ' v:' ;
					maPrint: (self valueAtByteArrayIndex: eachBax) ;
					maPrint: ' r:' ;
					maPrint: (self recordNumberAtByteArrayIndex: eachBax) ;
					maPrint: ' c:' ;
					maPrint: (self numberOfChildrenAtByteArrayIndex: eachBax) ;
					endEntry ] ]! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 4/28/2005 21:47'!
dumpStructureTo: aStream
	self
		maPrintAttributes: #(
			recordNumber lowKey highKey canHoldDuplicateKeys keys recordNumbers values
			allNumberOfChildren possibleKeys)
		on: aStream! !

!MaHashIndexRecord methodsFor: 'actions' stamp: ''!
eligibleByteArrayIndexesFor: keyInteger do: oneArgBlock

	(self lowestByteArrayIndexFor: keyInteger)
		to: (self highestByteArrayIndexFor: keyInteger)
		by: entrySize
		do: [ :index | oneArgBlock value: index ]
! !

!MaHashIndexRecord methodsFor: 'actions' stamp: 'cmm 3/10/2004 01:00'!
eligibleByteArrayIndexesFor: keyInteger reverseDo: oneArgBlock

	(self highestByteArrayIndexFor: keyInteger)
		to: (self lowestByteArrayIndexFor: keyInteger)
		by: 0-entrySize
		do: [ :index | oneArgBlock value: index ]
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/12/2004 15:37'!
entryWeight

	^ entryWeight! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasChildAtByteArrayIndex: byteArrayIndex

	^(self recordNumberAtByteArrayIndex: byteArrayIndex) > 0
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: 'cmm 12/1/2002 21:44'!
hasChildAtHighestByteArrayIndexForBax: byteArrayIndex

	^(self recordNumberAtHighestByteArrayIndexForBax: byteArrayIndex) > 0! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasEntryAtByteArrayIndex: anInteger

	^(self hasSlotAvailableAtByteArrayIndex: anInteger) not
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasEntryForKey: keyInteger
	"Answer whether keyInteger resides in an entry of the receiver."

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :index |
			((self hasEntryAtByteArrayIndex: index)
				and: [ (self keyAtByteArrayIndex: index) = keyInteger ])
					ifTrue:
						[ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: 'cmm 9/1/2006 17:57'!
hasSlotAvailableAtByteArrayIndex: anInteger
	^ (self controlAtByteArrayIndex: anInteger) maIsBitClear: self slotFilledControlBit! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
headerSize
	"Low and high keys.
	^(keySize / 8) * 2  simplified to / 4 for max performance."

	^keySize / 4
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
highKey

	^byteArray
		maUint: keySize
		at: keySize / 8
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
highKey: anInteger

	^byteArray
		maUint: keySize
		at: (keySize / 8)
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 17:12'!
highestByteArrayIndexFor: keyInteger
	"This will vary from the lowestByteArrayIndexFor: keyInteger only when the receiver canHoldDuplicateKeys."

	^ self byteArrayIndexFor: (self highestSlotIndexFor: keyInteger)! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 17:00'!
highestByteArrayIndexForAnyKeyAt: byteArrayIndex
	"this is for records that canHoldDuplicateKeys when we need to find the next child record number, since that is stored at the highestByteArrayIndexFor: that key."

	^self highestByteArrayIndexFor: (self lowestKeyAtIndex: (self slotIndexForBax: byteArrayIndex))! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/12/2004 10:51'!
highestKeyAtIndex: anInteger

	^canHoldDuplicateKeys
		ifTrue:
			[ self lowestKeyAtIndex: anInteger ]
		ifFalse:
			[ (self lowestKeyAtIndex: anInteger + 1) - 1 ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/11/2004 21:19'!
highestPossibleKey

	^ (2 raisedTo: keySize) - 1! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 7/1/2005 17:11'!
highestSlotIndexFor: keyInteger

	^ canHoldDuplicateKeys
		ifTrue:
			[ (self slotIndexFor: keyInteger + 1) - 1 ]
		ifFalse:
			[ self slotIndexFor: keyInteger ]! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
incrementNumberOfChildrenAtByteArrayIndex: anInteger

	| currentNumberOfChildren |

	currentNumberOfChildren := self numberOfChildrenAtByteArrayIndex: anInteger.
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren + 1
! !

!MaHashIndexRecord methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:03'!
independentCopy

	^ self copy postIndependentCopy! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
keyAtByteArrayIndex: anInteger

	^byteArray
		maUint: keySize
		at: anInteger + self keyEntryOffset
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
keyAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: keySize
		at: index + self keyEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
keyAtHighestSlotFor: keyInteger

	^self keyAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 17:13'!
keyAtSlotIndex: anInteger

	^ self keyAtByteArrayIndex: (self byteArrayIndexFor: anInteger)! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 4/28/2005 22:44'!
keyEntryOffset

	^ self recordNumberEntryOffset + self sizeOfRecordNumber! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/11/2004 21:53'!
keySize

	^ keySize! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 9/1/2006 18:29'!
keySize: keyBits valueSize: valueBits numberOfSlots: numberOfSlotsInteger
	keySize := keyBits.
	valueSize := valueBits.
	numberOfSlots := numberOfSlotsInteger.
	"Each entry consists of:  value, record number, key, number of child entries."
	entrySize := self sizeOfControlFieldInBytes + (valueSize/8) + self sizeOfRecordNumber + ((keySize / 8) * 2).
	byteArray := ByteArray new: self headerSize + (entrySize * numberOfSlotsInteger)! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
keys
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self keyAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
lowKey

	^byteArray
		maUint: keySize
		at: 0
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
lowKey: anInteger

	^byteArray
		maUint: keySize
		at: 0
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 7/1/2005 17:08'!
lowestByteArrayIndexFor: keyInteger

	^self byteArrayIndexFor: (self slotIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 7/1/2005 16:51'!
lowestKeyAtIndex: entryIndex
	"Answer the lowest-possible key that can be stored at entryIndex."

	^ lowKey + (entryIndex * entryWeight // numberOfSlots)! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 12/29/2005 22:59'!
lowestPossibleKey
	^ 0! !

!MaHashIndexRecord methodsFor: 'printing' stamp: 'cmm 9/10/2006 14:17'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(recordNumber lowKey highKey entryWeight possibleKeys canHoldDuplicateKeys)
		on: aStream.
	aStream cr; maPrint: 'entries:'.
	self dumpEntriesTo: aStream! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
numberOfChildren

	| total |

	total := 0.
	self
		byteArrayIndexesFrom: 0
		do: [ :index | total := total + (self numberOfChildrenAtByteArrayIndex: index) ].
	^total
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:51'!
numberOfChildrenAtByteArrayIndex: anInteger

	^byteArray
		maUint: keySize
		at: anInteger + self numberOfChildrenEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:57'!
numberOfChildrenAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: keySize
		at: index + self numberOfChildrenEntryOffset
		put: anInteger! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 17:08'!
numberOfChildrenBefore: keyInteger

	| lastByteArrayIndex entryIndex totalInSlotsBeforeKey |

	entryIndex := self slotIndexFor: keyInteger.
	lastByteArrayIndex := self byteArrayIndexFor: entryIndex.
	totalInSlotsBeforeKey := self numberOfChildrenBeforeByteArrayIndex: lastByteArrayIndex.
	^((self keyAtByteArrayIndex: lastByteArrayIndex) < keyInteger
		and: [ self hasEntryAtByteArrayIndex: lastByteArrayIndex ])
			ifTrue:
				[ (lastByteArrayIndex = (self highestByteArrayIndexFor: keyInteger))
					ifTrue: [ totalInSlotsBeforeKey + 1 ]
					ifFalse: [ totalInSlotsBeforeKey + (self numberOfChildrenAtByteArrayIndex: lastByteArrayIndex) ] ]
			ifFalse: [ totalInSlotsBeforeKey ]! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/22/2002 00:13'!
numberOfChildrenBeforeByteArrayIndex: anInteger

	| total |

	total := 0.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			each = anInteger ifTrue: [ ^total ].
			total := total + (self numberOfChildrenAtByteArrayIndex: each) ].
	self error: anInteger printString, ' is not a valid byteArrayIndex.'! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/30/2002 21:20'!
numberOfChildrenEntryOffset

	^self keyEntryOffset + (keySize / 8)! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 16:51'!
numberOfSlots

	^ numberOfSlots! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 9/1/2006 18:45'!
occupySlotAtByteArrayIndex: anInteger 
	| controlValue |
	controlValue := self controlAtByteArrayIndex: anInteger.
	self 
		controlAtByteArrayIndex: anInteger
		put: (controlValue maBitSet: self slotFilledControlBit)! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 11/27/2011 20:05'!
populateFrom: aMaHashIndexRecord
	byteArray
		replaceFrom: 1
		to: byteArray size
		with: aMaHashIndexRecord byteArray.
	recordNumber := aMaHashIndexRecord recordNumber.
	self resetForNewKeyRange! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 7/1/2005 16:51'!
possibleKeys

	| answer |

	answer := WriteStream on: (String new: numberOfSlots * 2).
	0
		to: numberOfSlots - 1
		do:
			[ : index |  | low high |
			low := self lowestKeyAtIndex: index.
			high := self highestKeyAtIndex: index.
			answer nextPutAll: ' | '.
			low = high
				ifTrue:
					[ answer maPrint: low ]
				ifFalse:
					[ answer
						maPrint: low;
						maPrint: '..';
						maPrint: high ] ].
	^ answer contents! !

!MaHashIndexRecord methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:03'!
postIndependentCopy

	byteArray := byteArray copy! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/29/2005 23:00'!
postInitialize

	self
		beFrom: self lowestPossibleKey 
		to: self highestPossibleKey! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
recordNumber

	^recordNumber! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
recordNumber: anInteger

	recordNumber := anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
recordNumberAtByteArrayIndex: anInteger

	^byteArray 
		maUint: 32
		at: anInteger + self recordNumberEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:58'!
recordNumberAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: 32
		at: index + self recordNumberEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 12/1/2002 20:57'!
recordNumberAtHighestByteArrayIndexForBax: anInteger

	^self recordNumberAtByteArrayIndex: (self highestByteArrayIndexForAnyKeyAt: anInteger)! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
recordNumberAtSlotForKey: keyInteger put: recordNumberInteger

	self
		recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
		put: recordNumberInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
recordNumberCloserTo: keyInteger

	^self recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 8/30/2006 21:08'!
recordNumberEntryOffset
	^ self valueEntryOffset + (valueSize/8 "bits")! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
recordNumbers
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self recordNumberAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 9/10/2006 20:56'!
removeKey: keyInteger withValue: valueInteger 
	self 
		eligibleByteArrayIndexesFor: keyInteger
		do: 
			[ : each | 
			((self keyAtByteArrayIndex: each) = keyInteger 
			and: [ (self valueAtByteArrayIndex: each) = valueInteger
			and: [ self hasEntryAtByteArrayIndex: each ] ]) ifTrue: 
				[ self
					vacateSlotAtByteArrayIndex: each ;
					decrementNumberOfChildrenAtByteArrayIndex: each.
				^ each ] ].
	^ nil! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 11/27/2011 20:03'!
resetForNewKeyRange
	lowKey := self lowKey.
	highKey := self highKey.
	canHoldDuplicateKeys := (highKey - lowKey + 1) < numberOfSlots.
	entryWeight := highKey - lowKey + 1! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 7/1/2005 16:51'!
setLowKey: lowKeyInteger highKey: highKeyInteger

	lowKey := self lowKey.
	highKey := self highKey.
	canHoldDuplicateKeys := (highKey - lowKey + 1) < numberOfSlots.
	entryWeight := highKey - lowKey + 1! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 8/30/2006 21:17'!
sizeOfControlFieldInBits
	^ 8! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 8/30/2006 21:17'!
sizeOfControlFieldInBytes
	^ 1! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/30/2002 21:35'!
sizeOfRecordNumber

	^4! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 9/1/2006 17:39'!
slotFilledControlBit
	"Bit #1 of the  1-byte control field is used to mark whether a particular slot is filled or empty."
	^ 1! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 8/17/2005 19:18'!
slotIndexFor: keyInteger
	"The lowest slot index in which keyInteger can reside."

	^ (keyInteger - lowKey) * numberOfSlots // entryWeight! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 7/1/2005 16:59'!
slotIndexForBax: anInteger
	"Bax means 'byteArrayIndex'."

	^(anInteger - self headerSize) / entrySize! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/11/2004 21:41'!
structure

	^ String streamContents: [ : stream | self dumpStructureTo: stream ]! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 9/1/2006 18:45'!
vacateSlotAtByteArrayIndex: anInteger 
	| controlValue |
	controlValue := self controlAtByteArrayIndex: anInteger.
	self 
		controlAtByteArrayIndex: anInteger
		put: (controlValue maBitClear: self slotFilledControlBit)! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 4/28/2005 21:44'!
valueAtByteArrayIndex: anInteger

	^ byteArray 
		maUint: valueSize
		at: anInteger + self valueEntryOffset! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 4/28/2005 21:44'!
valueAtByteArrayIndex: index put: anInteger

	^ byteArray
		maUint: valueSize
		at: index + self valueEntryOffset
		put: anInteger! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 8/30/2006 21:17'!
valueEntryOffset
	^ self controlEntryOffset + self sizeOfControlFieldInBytes! !

!MaHashIndexRecord methodsFor: 'printing' stamp: 'cmm 4/28/2005 21:52'!
values
	"This is intended to be used only for printing!!"

	^ (self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ : index | self valueAtByteArrayIndex: index ]! !

MaObject subclass: #MaHashIndexHeader
	instanceVariableNames: 'byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaHashIndexHeader class methodsFor: 'accessing' stamp: 'cmm 4/5/2007 00:10'!
currentVersion
	^ 2! !

!MaHashIndexHeader class methodsFor: 'accessing' stamp: 'cmm 4/4/2007 23:45'!
headerSize
	"Header consists of:
		version:  8 bits
		keySize:  16 bits
		valueSize: 16 bits
		recordSize: 8 bits"
	^ 100! !

!MaHashIndexHeader class methodsFor: 'accessing' stamp: 'cmm 4/5/2007 00:11'!
version
	"The highest version this HashIndex can support."
	^ 2! !

!MaHashIndexHeader methodsFor: 'initialize' stamp: 'cmm 4/4/2007 23:45'!
byteArray: aByteArray
	byteArray := aByteArray! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/5/2007 00:02'!
headerBytesForKeySize: keySize valueSize: valueSize recordSize: hashRecordSize 
	self
		keySize: keySize ;
		valueSize: valueSize ;
		recordSize: hashRecordSize.
	^ byteArray! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/8/2007 20:13'!
headerSize
	^ self version = 1 
		ifTrue: [ 3 ]
		ifFalse: [ 100 ]! !

!MaHashIndexHeader methodsFor: 'initialize' stamp: 'cmm 4/4/2007 23:44'!
initialize
	super initialize.
	byteArray := ByteArray new: self class headerSize! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/8/2007 19:58'!
keySize
	^ self version in: 
		[ : version | 
		| modifier |
		modifier := version = 1 
			ifTrue: [ 1 ]
			ifFalse: [ 0 ].
		(byteArray 
			maUint: (self sizeOfKeySizeForVersion: version)
			at: (self positionOfKeySizeForVersion: version)) + modifier ]! !

!MaHashIndexHeader methodsFor: 'initialize' stamp: 'cmm 4/4/2007 23:58'!
keySize: anInteger 
	byteArray 
		maUint: 16
		at: (self positionOfKeySizeForVersion: self class version)
		put: anInteger! !

!MaHashIndexHeader methodsFor: 'printing' stamp: 'cmm 4/8/2007 19:56'!
maPrintAbbreviatedOn: aStream 
	super maPrintAbbreviatedOn: aStream.
	self 
		maPrintAttributes: #(
				#version
				#keySize
				#valueSize
				#recordSize
			)
		on: aStream! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/4/2007 23:57'!
positionOfKeySizeForVersion: anInteger 
	^ anInteger = 1 
		ifTrue: [ 0 ]
		ifFalse: [ 2 ]! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/5/2007 00:00'!
positionOfRecordSizeForVersion: anInteger 
	^ anInteger = 1 
		ifTrue: [ 2 ]
		ifFalse: [ 6 ]! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/5/2007 00:01'!
positionOfValueSizeForVersion: anInteger 
	^ anInteger = 1 
		ifTrue: [ 1 ]
		ifFalse: [ 4 ]! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/4/2007 23:51'!
positionOfVersion
	"Position of the version for version 2+ HashIndexes."
	^ 1! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/4/2007 23:50'!
positionOfVersion1Indicator
	"The first version of MaHashIndex did not have the foresight to include a version indicator.  However, position 0 of the header is the keySize, which can never be 0.  Therefore, version 2+ reserves position 0 for the 'version 1 indicator', which, if 0, is NOT version 1, if it is >0, it *is* verison 1."
	^ 0! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/5/2007 00:08'!
recordSize
	^ byteArray 
		maUint: 8
		at: (self positionOfRecordSizeForVersion: self version)! !

!MaHashIndexHeader methodsFor: 'initialize' stamp: 'cmm 4/5/2007 00:00'!
recordSize: anInteger 
	byteArray 
		maUint: 8
		at: (self positionOfRecordSizeForVersion: self class version)
		put: anInteger! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/5/2007 00:07'!
sizeOfKeySizeForVersion: anInteger 
	^ anInteger = 1 
		ifTrue: [ 8 ]
		ifFalse: [ 16 ]! !

!MaHashIndexHeader methodsFor: 'private' stamp: 'cmm 4/5/2007 00:07'!
sizeOfValueSizeForVersion: anInteger 
	^ anInteger = 1 
		ifTrue: [ 8 ]
		ifFalse: [ 16 ]! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/8/2007 20:07'!
valueSize
	^ self version in: 
		[ : version | 
		| modifier |
		modifier := version = 1 
			ifTrue: [ 1 ]
			ifFalse: [ 0 ].
		(byteArray 
			maUint: (self sizeOfValueSizeForVersion: version)
			at: (self positionOfValueSizeForVersion: version)) + modifier ]! !

!MaHashIndexHeader methodsFor: 'initialize' stamp: 'cmm 4/5/2007 00:01'!
valueSize: anInteger 
	byteArray 
		maUint: 16
		at: (self positionOfValueSizeForVersion: self class version)
		put: anInteger! !

!MaHashIndexHeader methodsFor: 'accessing' stamp: 'cmm 4/4/2007 23:48'!
version
	^ (byteArray 
		maUint: 8
		at: self positionOfVersion1Indicator) = 0 
		ifTrue: 
			[ byteArray 
				maUint: 8
				at: self positionOfVersion ]
		ifFalse: [ 1 ]! !

MaObject subclass: #MaHashIndexRecordFactory
	instanceVariableNames: 'index recordNumbersPath entryIndexPath byteArrayIndexPath recordPath preMadeNewRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-private'!

!MaHashIndexRecordFactory class methodsFor: 'creation' stamp: 'cmm 12/4/2002 23:31'!
index: aMaHashIndex

	^self new
		index: aMaHashIndex;
		postInitialize;
		yourself! !

!MaHashIndexRecordFactory methodsFor: 'initializing' stamp: 'cmm 7/1/2005 17:15'!
createPreMadeNewRecord

	preMadeNewRecord :=
		MaHashIndexRecord
			keySize: index keySize
			valueSize: index valueSize
			numberOfSlots: index hashRecordSize
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
entryIndexAtLevel: anInteger

	^entryIndexPath at: anInteger
! !

!MaHashIndexRecordFactory methodsFor: 'private' stamp: 'cmm 12/4/2002 23:35'!
index: aMaHashIndex

	index := aMaHashIndex! !

!MaHashIndexRecordFactory methodsFor: 'initializing' stamp: 'cmm 7/1/2005 17:15'!
initializeRecordPathRecords

	1
		to: self maxDepth
		do:
			[ :x |
			recordPath
				at: x
				put: (
					MaHashIndexRecord
						keySize: index keySize
						valueSize: index valueSize
						numberOfSlots: index hashRecordSize) ]! !

!MaHashIndexRecordFactory methodsFor: 'private' stamp: 'cmm 4/2/2007 18:51'!
maxDepth
	"A shortcut way of saying, index highestPossibleKey log: index numberOfSlots."
	^ (index keySize / (index numberOfSlots log: 2)) asInteger
! !

!MaHashIndexRecordFactory methodsFor: 'initializing' stamp: 'cmm 12/4/2002 23:35'!
postInitialize

	recordNumbersPath := OrderedCollection new: self maxDepth.
	entryIndexPath := OrderedCollection new: self maxDepth.
	byteArrayIndexPath := OrderedCollection new: self maxDepth.
	recordPath := Array new: self maxDepth.
	self
		createPreMadeNewRecord;
		initializeRecordPathRecords! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
preMadeNewRecord

	^preMadeNewRecord! !

!MaHashIndexRecordFactory methodsFor: 'building' stamp: 'cmm 7/1/2005 17:00'!
put: aMaHashIndexRecord atLevel: levelInteger byteArrayIndex: indexInteger

	levelInteger > recordNumbersPath size
		ifTrue:
			[ recordNumbersPath add: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath add: indexInteger.
			entryIndexPath add: (aMaHashIndexRecord slotIndexForBax: indexInteger) ]
		ifFalse:
			[ recordNumbersPath
				at: levelInteger
				put: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath
				at: levelInteger
				put: indexInteger.
			entryIndexPath
				at: levelInteger
				put: (aMaHashIndexRecord slotIndexForBax: indexInteger) ].
	levelInteger > recordPath size
		ifFalse:
			[ (recordPath at: levelInteger) populateFrom: aMaHashIndexRecord ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: 'cmm 11/29/2002 22:47'!
recordAtLevel: levelInteger

	^levelInteger > recordPath size
		ifTrue:
			[ recordPath first independentCopy ]
		ifFalse:
			[ recordPath at: levelInteger ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
recordNumberAtLevel: anInteger

	^recordNumbersPath at: anInteger
! !

MaObject subclass: #MaIntervalCollection
	instanceVariableNames: 'intervals proximityThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaIntervalCollection commentStamp: 'cmm 6/4/2005 00:48' prior: 0!
This class keeps track of a collection of intervals.

As intervals are added that intersect or are within the proximityThreshold
of existing intervals, the existing interval is enlarged to include for the new interval.

If an interval is removed in the middle of a large interval such that
a "hole" is created, a new interval will be created and the other one
will be adjusted so that they will represent only the valid ranges.

For example:

	if an instance of this class has 1..10

	and we add: 8..15, then this class will have a single interval from 1..15

	Then remove 5..11..  Assuming a proximityThreshold of 1, this class will have the following two intervals:

		1..4
		12..15

Use a proximityThreshold of 0 to track the real-numbers..!

!MaIntervalCollection methodsFor: 'add / remove' stamp: 'cmm 6/13/2005 15:43'!
addFrom: low to: high

	| intersecting lowestLow highestHigh |
	low > high ifTrue: [ self error: 'low should be lower than high' ].
	intersecting := self intervalsIntersecting: (self expandedFrom: low to: high).
	lowestLow := low.
	highestHigh := high.
	intersecting do:
		[ : each |
		lowestLow := lowestLow min: each first.
		highestHigh := highestHigh max: each last ].
	intervals
		removeAll: intersecting ;
		add: (lowestLow to: highestHigh)! !

!MaIntervalCollection methodsFor: 'private' stamp: 'cmm 6/4/2005 01:04'!
expandedFrom: low to: high

	^ low-proximityThreshold to: high+proximityThreshold! !

!MaIntervalCollection methodsFor: 'testing' stamp: 'cmm 6/4/2005 01:07'!
includes: aNumber

	^ intervals anySatisfy: [ : each | each includes: aNumber ]! !

!MaIntervalCollection methodsFor: 'private' stamp: 'cmm 6/4/2005 01:08'!
initialize
	super initialize.
	intervals := SortedCollection sortBlock: [ : a : b | a first < b first ].
	proximityThreshold := 1! !

!MaIntervalCollection methodsFor: 'enumerating' stamp: 'cmm 4/12/2006 10:48'!
intervalsDo: aBlock
	intervals do: aBlock! !

!MaIntervalCollection methodsFor: 'private' stamp: 'cmm 6/4/2005 17:22'!
intervalsInside: anInterval

	^ intervals select: [ : each | anInterval maEnvelopes: each ]! !

!MaIntervalCollection methodsFor: 'private' stamp: 'cmm 6/4/2005 01:04'!
intervalsIntersecting: anInterval

	^ intervals select: [ : each | each maIntersects: anInterval ]! !

!MaIntervalCollection methodsFor: 'printing' stamp: 'cmm 6/4/2005 18:04'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	intervals do:
		[ : each |
		aStream 
			maPrint: each first ;
			maPrint: '..' ;
			maPrint: each last ;
			space ]! !

!MaIntervalCollection methodsFor: 'copying' stamp: 'cmm 10/19/2005 10:05'!
postCopy
	super postCopy.
	intervals := intervals copy! !

!MaIntervalCollection methodsFor: 'add / remove' stamp: 'cmm 6/4/2005 18:19'!
removeFrom: low to: high
"Removing is a two-step process:
1) remove intervals completely contained by input
2) adjust intersecting intervals
	- each intersects input-low only, set its high to input-low
	- each intersects input-high only, set its low to input-high
	- each intersects input-low and input-high, set its high to inputs-low and addFrom: inputs-high to its original high"

	(self intervalsInside: (low to: high)) do: [ : each | intervals remove: each ].
	(self intervalsIntersecting: (self expandedFrom: low to: high))
		do: 
			[ : each |  | eachIntersectsLow eachIntersectsHigh |
			eachIntersectsLow := low between: each first and: each last.
			eachIntersectsHigh := high between: each first and: each last.
			{ eachIntersectsLow. eachIntersectsHigh } caseOf:
				{ [ { true. false } ] -> [ each setFrom: each first to: high by: each increment ].
				[ { false. true } ] -> [ each setFrom: low to: each last by: each increment ].
				[ { true. true } ] -> 
					[ | oldHigh |
					oldHigh := each last.
					each setFrom: each first to: low by: each increment.
					self addFrom: high to: oldHigh ] } ]! !

MaObject subclass: #MaLargeArrayOfRecords
	instanceVariableNames: 'broker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaLargeArrayOfRecords commentStamp: 'cmm 3/18/2007 23:38' prior: 0!
I represent large Array of ByteArray "records".  I am capable of being truly large when my 'broker' is a MaFileRecordBroker, and I am mostly used with such a broker, even though my default is an MaInImageRecordBroker.!

MaLargeArrayOfRecords subclass: #MaLargeArrayOfNumbers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaLargeArrayOfNumbers commentStamp: 'cmm 3/18/2007 22:59' prior: 0!
MaLargeArrayOfNumbers is an auto-growing, never-shrinking array of numbers.  All numbers have the same number of bits available to represent them.!

!MaLargeArrayOfNumbers class methodsFor: 'utilities' stamp: 'cmm 6/13/2005 23:09'!
create: aReadWriteStream bitSize: anInteger

	^ (self newWithBitSize: anInteger)
		create: aReadWriteStream ;
		yourself! !

!MaLargeArrayOfNumbers class methodsFor: 'utilities' stamp: 'cmm 12/3/2011 15:56'!
createNamed: filenameString bitSize: anInteger 
	| file |
	(StandardFileStream isAFileNamed: filenameString) ifTrue: [ MaEnvironmentError signal: filenameString , ' already exists.' ].
	file := StandardFileStream fileNamed: filenameString.
	(file isNil or: [ file closed ]) ifTrue: [ MaEnvironmentError signal: 'Could not create ' , filenameString ].
	^ self
		create: file
		bitSize: anInteger! !

!MaLargeArrayOfNumbers class methodsFor: 'creation' stamp: 'cmm 5/23/2005 17:45'!
newWithBitSize: anInteger

	^ self new
		byteSize: anInteger / 8 ;
		yourself! !

!MaLargeArrayOfNumbers class methodsFor: 'accessing' stamp: 'cmm 3/20/2005 19:23'!
suggestedFileExtension
	^ 'idx'! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: ''!
add: anInteger

	^self
		at: self size + 1
		put: anInteger
! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 3/15/2005 21:42'!
at: index

	^ self
		at: index
		ifAbsent: [ self error: 'index out of bounds' ]! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 3/20/2007 21:42'!
at: logicalIndex ifAbsent: aBlock 
	| bytes |
	(self includesKey: logicalIndex) ifFalse: [ ^ aBlock value ].
	broker 
		readInto: (bytes := self newRecordBytes)
		at: logicalIndex - 1.
	^ bytes 
		maUint: broker recordSize * 8
		at: 0! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 3/20/2007 21:49'!
at: logicalIndex put: anInteger 
	| bytes |
	logicalIndex > self maxSize ifTrue: [ MaUserError signal: 'Out of range.' ].
	bytes := self newRecordBytes.
	bytes
		maUint: broker recordSize * 8
		at: 0
		put: anInteger.
	broker 
		writeFrom: bytes
		at: logicalIndex - 1.
	^ anInteger! !

!MaLargeArrayOfNumbers methodsFor: 'private' stamp: 'cmm 3/20/2007 21:36'!
byteSize: anInteger 
	broker
		headerSize: self headerSize ;
		recordSize: anInteger! !

!MaLargeArrayOfNumbers methodsFor: 'private' stamp: ''!
headerSize
	"Header consists of:
		number of bits per Integer in the receiver."
	^1
! !

!MaLargeArrayOfNumbers methodsFor: 'testing' stamp: 'cmm 6/4/2005 18:38'!
includesKey: anInteger

	^ anInteger
		between: 1
		and: self size! !

!MaLargeArrayOfNumbers methodsFor: 'initialize' stamp: 'cmm 3/20/2007 21:34'!
initializeFromHeader: aByteArray 
	broker recordSize:
		(aByteArray 
			maUint: 8
			at: 0)! !

!MaLargeArrayOfNumbers methodsFor: 'printing' stamp: 'cmm 2/5/2003 00:25'!
maPrintAbbreviatedOn: aStream

	1
		to: (self size min: 100)
		do:
			[ :each |
			aStream
				space;
				maPrint: (self at: each ifAbsent: [ 'error at: ', each printString ]) ].
	self size > 100 ifTrue: [ aStream nextPutAll: ' ...' ]! !

!MaLargeArrayOfNumbers methodsFor: 'private' stamp: 'cmm 3/15/2005 21:40'!
maxFileSize

	^ 2000000000! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 5/19/2005 10:39'!
maxSize

	^ self maxFileSize // broker recordSize! !

!MaLargeArrayOfNumbers methodsFor: 'initialize' stamp: 'cmm 5/19/2005 10:43'!
newHeaderBytes
	"Answer a new ByteArray containing the header for the receiver.
	This is only used when creating the an instance of this class with
	the create: constructor."

	^(ByteArray new: self headerSize)
		maUint: 8
		at: 0
		put: broker recordSize;
		yourself
! !

!MaLargeArrayOfNumbers methodsFor: 'private' stamp: 'cmm 3/20/2007 21:40'!
newRecordBytes
	^ ByteArray new: broker recordSize! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 5/17/2005 23:39'!
size

	^ broker size! !

!MaLargeArrayOfNumbers methodsFor: 'accessing' stamp: 'cmm 4/13/2005 15:27'!
upTo: countInteger startingAt: startInteger

	| answer size targetX |
	size := self size.
	startInteger > size ifTrue: [ ^ #() ].
	answer := Array new: (countInteger min: size-startInteger+1).
	targetX := 0.
	startInteger to: (startInteger+countInteger-1 min: size) do:
		[ : sourceX |
		answer
			at: (targetX := targetX + 1)
			put: (self at: sourceX) ].
	^ answer! !

!MaLargeArrayOfRecords class methodsFor: 'create' stamp: 'cmm 6/14/2005 10:34'!
open: aReadWriteStream

	^ self new open: aReadWriteStream! !

!MaLargeArrayOfRecords class methodsFor: 'create' stamp: 'cmm 12/3/2011 15:56'!
openNamed: filenameString 
	| file |
	(StandardFileStream isAFileNamed: filenameString) ifFalse: [ MaEnvironmentError signal: filenameString , ' does not exist.' ].
	file := StandardFileStream fileNamed: filenameString.
	(file isNil or: [ file closed ]) ifTrue: [ MaEnvironmentError signal: 'Could not create ' , filenameString ].
	^ self open: file binary! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 6/14/2005 10:41'!
close

	broker close! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 7/11/2005 22:37'!
create: aReadWriteStream

	broker := 
		(MaFileRecordBroker headerSize: self headerSize)
			recordSize: broker recordSize ;
			yourself.
	broker create: aReadWriteStream.
	self writeHeader! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 5/22/2005 21:24'!
delete

	broker delete! !

!MaLargeArrayOfRecords methodsFor: 'access' stamp: 'cmm 6/6/2005 12:31'!
filename

	^ broker filename! !

!MaLargeArrayOfRecords methodsFor: 'access' stamp: 'cmm 7/6/2005 22:52'!
filesDo: oneArgBlock

	broker filesDo: oneArgBlock! !

!MaLargeArrayOfRecords methodsFor: 'subclass responsibility' stamp: 'cmm 7/18/2005 13:27'!
headerSize

	self subclassResponsibility! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 5/23/2005 17:35'!
initialize

	super initialize.
	broker := MaInImageRecordBroker new! !

!MaLargeArrayOfRecords methodsFor: 'subclass responsibility' stamp: 'cmm 5/18/2005 16:22'!
initializeFromHeader: aByteArray

	self subclassResponsibility! !

!MaLargeArrayOfRecords methodsFor: 'subclass responsibility' stamp: 'cmm 6/30/2005 23:14'!
newHeaderBytes

	self subclassResponsibility! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 6/14/2005 10:10'!
open: aReadWriteStream

	broker := MaFileRecordBroker headerSize: self headerSize.
	broker open: aReadWriteStream.
	self readHeader! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 5/19/2005 10:13'!
readHeader

	| headerBytes |
	headerBytes := ByteArray new: self headerSize.
	broker readHeaderInto: headerBytes.
	self initializeFromHeader: headerBytes! !

!MaLargeArrayOfRecords methodsFor: 'initialize-release' stamp: 'cmm 5/18/2005 15:53'!
writeHeader

	broker writeHeaderFrom: self newHeaderBytes! !

MaLargeArrayOfRecords subclass: #MaMagnitudeIndex
	instanceVariableNames: 'keySize valueSize nextRecordNumber highestPossibleKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaMagnitudeIndex commentStamp: '<historical>' prior: 0!
keySize in bits.!

MaMagnitudeIndex subclass: #MaHashIndex
	instanceVariableNames: 'hashRecordSize record recordFactory guard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Numbers collections'!

!MaHashIndex class methodsFor: 'creation' stamp: 'cmm 6/13/2005 23:07'!
create: aReadWriteStream keySize: numberOfBitsInteger valueSize: valueSize recordSize: entriesInteger

	^ (self
		newWithKeySize: numberOfBitsInteger
		valueSize: valueSize
		recordSize: entriesInteger)

		create: aReadWriteStream ;
		yourself! !

!MaHashIndex class methodsFor: 'creation' stamp: 'cmm 12/3/2011 15:56'!
createNamed: filenameString keySize: numberOfBitsInteger valueSize: valueSize recordSize: entriesInteger 
	| file |
	(StandardFileStream isAFileNamed: filenameString) ifTrue: [ MaEnvironmentError signal: filenameString , ' already exists.' ].
	file := StandardFileStream fileNamed: filenameString.
	(file isNil or: [ file closed ]) ifTrue: [ MaEnvironmentError signal: 'Could not create ' , filenameString ].
	^ self
		create: file binary
		keySize: numberOfBitsInteger
		valueSize: valueSize
		recordSize: entriesInteger! !

!MaHashIndex class methodsFor: 'creation' stamp: 'cmm 3/17/2011 22:43'!
newWithKeySize: numberOfBitsInteger valueSize: valueSize recordSize: entriesInteger
	"Use this constructor only when you want to create in-memory cached-hash-index."
	(self validRecordSizes includes: entriesInteger) 
		ifFalse: [ MaUserError signal: 'recordSize must be one of ', self validRecordSizes printString ].
	(self validKeySizes includes: numberOfBitsInteger) 
		ifFalse: [ MaUserError signal: 'keySize must be one of ', self validKeySizes printString ].
	^ self new
		keySize: numberOfBitsInteger
		valueSize: valueSize
		hashRecordSize: entriesInteger ;

		writeNewRoot ;
		yourself! !

!MaHashIndex class methodsFor: 'creation' stamp: ''!
suggestedFileExtension

	^'hdx'
! !

!MaHashIndex class methodsFor: 'accessing' stamp: 'cmm 11/17/2010 10:41'!
validKeySizes
	"Record sizes must be a power of 2 so that slots in every MaHashIndexRecord will be uniformely sized."
	^ 16
		to: 4096
		by: 8! !

!MaHashIndex class methodsFor: 'accessing' stamp: 'cmm 8/17/2005 21:21'!
validRecordSizes
	"Record sizes must be a power of 2 so that slots in every MaHashIndexRecord will be uniformely sized."

	^ #(2 4 8 16 32 64 128)! !

!MaHashIndex methodsFor: 'add / remove' stamp: 'cmm 11/27/2011 20:09'!
add: valueInteger at: keyInteger 
	"Find the record which either has space for keyInteger or is as far zoomed-in as possible (with either space for keyInteger or not).  If a record already contains another key greater than keyInteger, that entry must be 'pushed' down so we can maintain key order.  Additionally, we must increment the numberOfChildren for each record to the path of where we finally add."
	guard critical: 
		[ | currentKeyToWrite currentValueToWrite hasSpace reachedBottom |
		keyInteger > self highestPossibleKey ifTrue:
			[ MaHashIndexUserError signal: keyInteger printString, ' is larger than the highestPossibleKey.' ].
		currentKeyToWrite := keyInteger.
		currentValueToWrite := valueInteger.
		self selectRoot.
		hasSpace := false.
		reachedBottom := false.
		[ hasSpace | reachedBottom ] whileFalse: 
			[ | highestBax keyToMove valueToMove childRecordNumber |
			highestBax := record highestByteArrayIndexFor: currentKeyToWrite.
			((hasSpace := record canAdd: currentKeyToWrite) or: 
				[ (keyToMove := record keyAtHighestSlotFor: currentKeyToWrite) > currentKeyToWrite ]) 
				ifTrue: 
					[ hasSpace ifFalse: 
						[ valueToMove := record valueAtByteArrayIndex: highestBax.
						record vacateSlotAtByteArrayIndex: highestBax ].
					"Incrementing here is 'corrected', below, if necessary.."
					record incrementNumberOfChildrenAtByteArrayIndex: (record 
							atKey: currentKeyToWrite
							put: currentValueToWrite).
					hasSpace ifFalse: 
						[ "It should be safe to assume, here, that highestBax is where currentKeyToWrite was just placed."
						(record canAdd: keyToMove) 
							ifTrue: 
								[ record
									incrementNumberOfChildrenAtByteArrayIndex: (record 
											atKey: keyToMove
											put: valueToMove) ;
									decrementNumberOfChildrenAtByteArrayIndex: highestBax.
								hasSpace := true ]
							ifFalse: 
								[ "If the displaced entry will not be a child of the displacer, we need to correct the increment, (see) above, by decrement the numberOfChildren and incrementing where it *will* be placed."
								| newBax |
								newBax := record highestByteArrayIndexFor: keyToMove.
								highestBax = newBax ifFalse: 
									[ record
										decrementNumberOfChildrenAtByteArrayIndex: highestBax ;
										incrementNumberOfChildrenAtByteArrayIndex: newBax ] ] ] ]
				ifFalse: [ record incrementNumberOfChildrenAtByteArrayIndex: highestBax ].
			self writeRecord: record.
			valueToMove notNil ifTrue: 
				[ "we will need to push this key/value pair down"
				currentKeyToWrite := keyToMove.
				currentValueToWrite := valueToMove ].
			childRecordNumber := record recordNumberCloserTo: currentKeyToWrite.
			reachedBottom := childRecordNumber = 0.
			reachedBottom ifFalse: [ self selectRecord: childRecordNumber ] ].
		(reachedBottom and: [ hasSpace not ]) ifTrue: 
			[ self selectNewRecordFor: currentKeyToWrite.
			record incrementNumberOfChildrenAtByteArrayIndex: (record 
					atKey: currentKeyToWrite
					put: currentValueToWrite).
			self writeRecord ] ]! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 6/12/2006 22:48'!
allRecordsDo: twoArgBlock 
	guard critical: 
		[ self selectRoot.
		self 
			recordsFrom: record independentCopy
			do: twoArgBlock ]! !

!MaHashIndex methodsFor: 'add / remove' stamp: 'cmm 3/26/2006 19:22'!
at: key put: value
	"For collection api compatibility."
	self
		add: value
		at: key.
	^ value! !

!MaHashIndex methodsFor: 'initializing' stamp: 'cmm 7/18/2005 13:22'!
createRecord

	record :=
		(MaHashIndexRecord
			keySize: keySize
			valueSize: valueSize
			numberOfSlots: hashRecordSize)

				beFrom: 0
				to: (2 raisedTo: keySize) - 1;

				recordNumber: 0 ;
				yourself.
	broker recordSize: record bufferSize! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'sig 7/20/2007 11:14'!
do: aBlock for: aMagmaFileTraverser using: aMaReadStrategy

	self
		entriesFromIndex: 1
		do:
			[ :eachRecord :recordPosition :levels |
			aMagmaFileTraverser
				graphFrom: (eachRecord keyAtByteArrayIndex: recordPosition)
				do: aBlock
				using: aMaReadStrategy ]
		until:
			[ :eachRecord :recordPosition :levels | false ]
! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
entriesFrom: keyInteger do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	^self
		slotsFrom: keyInteger
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
entriesFromIndex: globalIndex do: threeArgBlock until: conditionBlock

	^self
		slotsFromIndex: globalIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 9/9/2006 23:42'!
findAnomalies
	| answer |
	answer := Dictionary new.
	self allRecordsDo:
		[ :eachParentRec :eachChildRec |
		(eachChildRec 
			addAnomaliesTo: answer 
			usingParent: eachParentRec) ifTrue:
				[ MaNotification new
					tag: answer;
					signal ] ].
	^answer! !

!MaHashIndex methodsFor: 'private' stamp: ''!
getNextRecordNumber

	^nextRecordNumber := nextRecordNumber + 1
! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 7/2/2005 17:06'!
hasAnomalies

	^ self findAnomalies notEmpty! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
hashRecordSize

	^hashRecordSize! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 4/5/2007 00:13'!
headerSize
	^ MaHashIndexHeader headerSize! !

!MaHashIndex methodsFor: 'testing' stamp: 'cmm 6/12/2006 22:50'!
includesKey: anInteger 
	^ guard critical: 
		[ self selectFirstRecordWithKeyEqualOrGreaterThan: anInteger.
		record hasEntryForKey: anInteger ]! !

!MaHashIndex methodsFor: 'testing' stamp: 'cmm 4/28/2005 21:55'!
includesValue: valueInteger at: keyInteger

	| hasEntry key |
	self
		entriesFrom: keyInteger
		do:
			[ : eachRecord : eachByteArrayIndex : level |
			(hasEntry and:
				[ key = keyInteger
					and: [ (eachRecord valueAtByteArrayIndex: eachByteArrayIndex) = valueInteger ] ])
						ifTrue:
							[ ^ true ] ]
		until:
			[ : eachRecord : eachByteArrayIndex : level |
			"Until we're on an entry that could not possibly hold keyInteger."
			((hasEntry := eachRecord hasEntryAtByteArrayIndex: eachByteArrayIndex)
				and: [ (key := eachRecord keyAtByteArrayIndex: eachByteArrayIndex) > keyInteger ])
					or: [ eachByteArrayIndex > (eachRecord highestByteArrayIndexFor: keyInteger) ] ].
	^ false! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
indexOf: keyInteger

	^self
		indexOfLowest: keyInteger
		exactKey: true
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 6/12/2006 17:27'!
indexOfHighest: keyInteger 
	"If keyInteger is present, answer the index of its last occurrence.  Otherwise, answer the index of the next lower key.  If keyInteger is lower than all keys in the receiver, answer 0."
	| lowestIndexOfNextHigherKey |
	^ guard critical: 
		[ keyInteger >= self highestPossibleKey ifTrue: [ ^ self size ].
		lowestIndexOfNextHigherKey := self 
			indexOfLowest: keyInteger + 1
			exactKey: false.
		lowestIndexOfNextHigherKey = 1 ifTrue: [ ^ 0 ].	"lower than all"
		lowestIndexOfNextHigherKey = 0 
			ifTrue: [ self size ]
			ifFalse: [ lowestIndexOfNextHigherKey - 1 max: 1 ] ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 6/12/2006 17:26'!
indexOfLowest: keyInteger exactKey: aBoolean 
	"If aBoolean is true, answer 0 if we don't find an exact key.  If false answer the index of the first equal or higher key."
	| total index |
	^ guard critical: 
		[ total := 0.
		self 
			navigateToward: keyInteger
			until: 
				[ : currentRecord | 
				| foundRecord |
				foundRecord := false.
				currentRecord 
					eligibleByteArrayIndexesFor: keyInteger
					do: 
						[ : each | 
						((currentRecord hasEntryAtByteArrayIndex: each) and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ]) ifTrue: [ foundRecord := true ] ].
				total := total + (record numberOfChildrenBefore: keyInteger).
				foundRecord ]
			do: 
				[ : currentRecord | "nada" ].
		"We now have the correct potential record selected and a correct total number of entries that occur before the entry that would contain keyInteger.  Now determine whether we should answer it or nil"
		index := total + 1.
		aBoolean 
			ifTrue: 
				[ (record hasEntryForKey: keyInteger) 
					ifTrue: [ ^ index ]
					ifFalse: [ 0 ] ]
			ifFalse: 
				[ index > self size 
					ifTrue: [ 0 ]
					ifFalse: [ index ] ] ]! !

!MaHashIndex methodsFor: 'initializing' stamp: 'cmm 9/23/2008 14:25'!
initialize
	super initialize.
	guard := Mutex new! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 4/8/2007 20:13'!
initializeFromHeader: aByteArray
	| header |
	header := MaHashIndexHeader new byteArray: aByteArray.
	self
		keySize: header keySize
		valueSize: header valueSize
		hashRecordSize: header recordSize.
	broker 
		headerSize: header headerSize ;
		recordSize: record bufferSize! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initializeRecordFactory

	recordFactory := MaHashIndexRecordFactory index: self
! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initializeRecords

	self
		createRecord;
		initializeRecordFactory
! !

!MaHashIndex methodsFor: 'analyzing' stamp: 'cmm 7/20/2011 15:34'!
keyCounts
	"Answer a Bag of the keys of the receiver."
	| counts c |
	counts := Bag new.
	c := 0.
	'enumerating ' , self filename 
		displayProgressFrom: 0
		to: self size
		during: 
			[ : bar | 
			self 
				entriesFrom: 0
				do: 
					[ : rec : bax : lvl | 
					bar value: (c := c + 1).
					counts add: (rec keyAtByteArrayIndex: bax) ]
				until: [ : rec : bax : lvl | false ] ].
	^ counts! !

!MaHashIndex methodsFor: 'initializing' stamp: 'cmm 5/23/2005 17:54'!
keySize: keySizeInteger valueSize: valueSizeInteger hashRecordSize: recordSizeInteger

	keySize := keySizeInteger.
	valueSize := valueSizeInteger.
	hashRecordSize := recordSizeInteger.
	self initializeRecords! !

!MaHashIndex methodsFor: 'enumerating' stamp: 'cmm 6/4/2006 12:53'!
keysAndValuesFrom: lowKey startingAt: anInteger do: twoArgBlock until: conditionBlock 
	"Value twoArgBlock with each key and value pair, until conditionBlock is false for same key-value pair, starting at anInteger after the lowest index of lowKey."
	| lowest currentIndex |
	currentIndex := 0.
	lowest := self 
		indexOfLowest: lowKey
		exactKey: false.
	lowest > 0 ifTrue: 
		[ self 
			entriesFromIndex: lowest + anInteger - 1
			do: 
				[ : currentRecord : byteArrayIndex : level | 
				currentIndex := currentIndex + 1.
				twoArgBlock 
					value: (currentRecord keyAtByteArrayIndex: byteArrayIndex)
					value: (currentRecord valueAtByteArrayIndex: byteArrayIndex) ]
			until: 
				[ : currentRecord : byteArrayIndex : level | 
				conditionBlock 
					value: (currentRecord keyAtByteArrayIndex: byteArrayIndex)
					value: (currentRecord valueAtByteArrayIndex: byteArrayIndex) ] ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/27/2002 13:22'!
navigateToward: keyInteger until: untilBlock do: doBlock
	"Select records between the root and the one that can contain keyInteger
	and value one-argument doBlock on each of those records until the
	one-argument untilBlock values true or we cannot navigate any
	closer to keyInteger."

	| level |

	level := 1.
	self selectRoot.
	[ | goalRecordReached bax |
	bax := record highestByteArrayIndexFor: keyInteger.
	recordFactory
		put: record
		atLevel: level
		byteArrayIndex: bax.
	goalRecordReached := untilBlock value: record.
	goalRecordReached not and: 	[ record hasChildAtByteArrayIndex: bax ] ]
		whileTrue:
			[ doBlock value: record.
			self selectRecord: (record recordNumberCloserTo: keyInteger).
			level := level + 1 ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 4/5/2007 00:02'!
newHeaderBytes
	^ MaHashIndexHeader new 
		headerBytesForKeySize: keySize
		valueSize: valueSize
		recordSize: hashRecordSize! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 6/12/2006 17:28'!
numberOfEntriesFrom: lowKey to: highKey 
	"Inclusive of lowKey and highKey, if those keys exist.
	If lowKey does not exist, we count from the next higher key.
	If highKey doesn't exist, we count up to the next highestKey."
	^ guard critical: 
		[ | lowest |
		(lowest := self 
			indexOfLowest: lowKey
			exactKey: false) = 0 ifTrue: [ ^ 0 ].
		(self indexOfHighest: highKey) - lowest + 1 ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 7/1/2005 16:54'!
numberOfSlots

	^ record numberOfSlots! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
occurrencesOf: keyInteger

	^self
		numberOfEntriesFrom: keyInteger
		to: keyInteger
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/27/2011 20:05'!
readRecord: aMaHashIndexRecord at: recordIndex 
	broker 
		readInto: aMaHashIndexRecord byteArray
		at: recordIndex.
	^ aMaHashIndexRecord
		resetForNewKeyRange ;
		recordNumber: recordIndex ;
		yourself! !

!MaHashIndex methodsFor: 'private' stamp: ''!
recordSize

	^record bufferSize
! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 6/12/2006 22:49'!
recordsDo: twoArgBlock level: level byteArrayIndex: anInteger 
	guard critical: 
		[ | parent |
		recordFactory 
			put: record
			atLevel: level
			byteArrayIndex: anInteger.
		parent := recordFactory recordAtLevel: level.
		twoArgBlock 
			value: parent
			value: level.
		parent 
			byteArrayIndexesFrom: 0
			do: 
				[ : eachBax | 
				(parent hasChildAtByteArrayIndex: eachBax) ifTrue: 
					[ self selectRecord: (parent recordNumberAtByteArrayIndex: eachBax).
					self 
						recordsDo: twoArgBlock
						level: level + 1
						byteArrayIndex: anInteger ] ] ]! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 6/12/2006 22:49'!
recordsFrom: aMaHashIndexRecord do: twoArgBlock 
	guard critical: 
		[ | childRec |
		aMaHashIndexRecord 
			byteArrayIndexesFrom: 0
			do: 
				[ : eachBax | 
				(aMaHashIndexRecord hasChildAtByteArrayIndex: eachBax) ifTrue: 
					[ childRec := aMaHashIndexRecord independentCopy.
					self 
						readRecord: childRec
						at: (aMaHashIndexRecord recordNumberAtByteArrayIndex: eachBax).
					twoArgBlock 
						value: aMaHashIndexRecord
						value: childRec.
					self 
						recordsFrom: childRec
						do: twoArgBlock ] ] ]! !

!MaHashIndex methodsFor: 'add / remove' stamp: 'cmm 9/1/2006 18:45'!
remove: valueInteger at: keyInteger 
	"Answer a boolean indicating whether anything was removed."
	guard critical: 
		[ | currentBaxToFill sourceBax parentRecord childRecord baxFilled |
		(self 
			includesValue: valueInteger
			at: keyInteger) ifFalse: [ ^ false ].
		self 
			navigateToward: keyInteger
			until: 
				[ : eachRecord | 
				(currentBaxToFill := eachRecord 
					removeKey: keyInteger
					withValue: valueInteger) notNil ]
			do: 
				[ : eachRecord | 
				"No need for beforeImageSignal here because we already signaled it in the until block."
				eachRecord decrementNumberOfChildrenAtKey: keyInteger.
				self writeRecord ].
		self writeRecord.

		"get out if we can.."
		currentBaxToFill ifNil: [ ^ true ].
		(record hasChildAtByteArrayIndex: currentBaxToFill) ifFalse: [ ^ true ].

		"Now pull up child record entries into the newly vacated slot because add looks for the first available slot that is eligible for the key it is adding, which *could* be greater than the key of the next child (meaning we'd then be out of order)."
		sourceBax := 0.	"non-nil"
		parentRecord := record independentCopy.
		childRecord := record independentCopy.
		
		[ sourceBax notNil and: [ parentRecord hasChildAtHighestByteArrayIndexForBax: currentBaxToFill ] ] whileTrue: 
			[ | highestByteArrayIndexForBaxToFill |
			highestByteArrayIndexForBaxToFill := parentRecord highestByteArrayIndexForAnyKeyAt: currentBaxToFill.
			self 
				readRecord: childRecord
				at: (parentRecord recordNumberAtByteArrayIndex: highestByteArrayIndexForBaxToFill).
			sourceBax := childRecord byteArrayIndexOfLowestEntry.
			sourceBax ifNotNil: 
				[ baxFilled := parentRecord 
					atKey: (childRecord keyAtByteArrayIndex: sourceBax)
					put: (childRecord valueAtByteArrayIndex: sourceBax).
				baxFilled ~= highestByteArrayIndexForBaxToFill ifTrue: 
					[ parentRecord incrementNumberOfChildrenAtByteArrayIndex: baxFilled.
					parentRecord decrementNumberOfChildrenAtByteArrayIndex: highestByteArrayIndexForBaxToFill ].
				childRecord
					decrementNumberOfChildrenAtByteArrayIndex: sourceBax ;
					vacateSlotAtByteArrayIndex: sourceBax.
				self
					writeRecord: parentRecord ;
					writeRecord: childRecord.
				parentRecord populateFrom: childRecord.
				currentBaxToFill := sourceBax ] ].
		^ true ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 7/1/2005 17:10'!
selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger
	"If keyInteger is larger than every key in the index, answer nil, otherwise answer the level of the record with the answer."

	| level searchedLevel |
	level := 1.
	self
		navigateToward: keyInteger
		until:
			[ : currentRecord |
			currentRecord
				eligibleByteArrayIndexesFor: keyInteger
				do:
					[ : each |
					((currentRecord hasEntryAtByteArrayIndex: each)
						and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ])
							ifTrue:
								[ ^ level ] ].
			false ]
		do: [ :currentRecord | level := level + 1 ].
	"Though we have arrived at the record which would contain keyInteger,
	in case it does not have entries whose keys are >= keyInteger,
	look for the next higher key."
	self
		traverseSlotsFromRecord: record
		index: (record slotIndexFor: keyInteger)
		do: [ : currentRecord : byteArrayIndex : currentLevel | "nothing" ]
		until:
			[ : currentRecord : byteArrayIndex : currentLevel |
			searchedLevel := currentLevel.
			currentRecord hasEntryAtByteArrayIndex: byteArrayIndex ]
		level: level.
	^ searchedLevel! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectNewRecordFor: keyInteger
	"We need to make sure we reference the new record from the
	current record."

	self setUpNewRecordFor: keyInteger.
	"Reference new record and write before selecting the new record."
	record
		recordNumberAtSlotForKey: keyInteger
		put: recordFactory preMadeNewRecord recordNumber.
	self
		writeRecord; "replace record that now references newRecord.."
		selectPreMadeNewRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectPreMadeNewRecord

	record populateFrom: recordFactory preMadeNewRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectRecord: anInteger

	self
		readRecord: record
		at: anInteger
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/30/2002 13:03'!
selectRecordAt: globalIndex
	"Answer the level and the byteArrayIndex of the selected record, or nil if out of bounds.
	Since the caller of this method is going to call traverseSlotsFromRecord:index:do:until:level:,
	we must be sure to populate the receivers path."

	| level byteArrayIndex currentGlobalPosition outOfBounds |

	self selectRoot.
	level := 1.
	currentGlobalPosition := 0.  "0-based"
	outOfBounds := false.
	[
		byteArrayIndex :=
			record
				byteArrayIndexContainingGlobalIndex: globalIndex
				base: currentGlobalPosition.
		byteArrayIndex isNil
			ifTrue:
				[ outOfBounds := true.
				false ]
			ifFalse:
				[ currentGlobalPosition :=
					currentGlobalPosition +
						(record numberOfChildrenBeforeByteArrayIndex: byteArrayIndex).
				(record hasEntryAtByteArrayIndex: byteArrayIndex)
					ifTrue: [ currentGlobalPosition := currentGlobalPosition + 1 ].
				(currentGlobalPosition < globalIndex) and:
					[ "this should never be false if above is true"
					record hasChildAtByteArrayIndex: byteArrayIndex ] ] ]
						whileTrue:
							[ recordFactory
								put: record
								atLevel: level
								byteArrayIndex: byteArrayIndex.
							self selectRecord:
								(record recordNumberAtByteArrayIndex: byteArrayIndex).
							level := level + 1 ].
	^outOfBounds
		ifTrue:
			[ nil ]
		ifFalse:
			[ Array
				with: byteArrayIndex
				with: level ]! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectRoot

	self selectRecord: 0
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
setUpNewRecordFor: keyInteger

	recordFactory preMadeNewRecord
		beZoomedInToward: keyInteger
			from: record;
		recordNumber: self getNextRecordNumber
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 6/12/2006 17:26'!
size
	^ guard critical: 
		[ self selectRoot.
		record numberOfChildren ]! !

!MaHashIndex methodsFor: 'enumerating' stamp: 'cmm 6/12/2006 22:46'!
slotsFrom: keyInteger do: threeArgBlock until: conditionBlock 
	"The first two arguments of threeArgBlock and conditionBlock are the record and the internal index position needed to access the of each entry in those records via keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.  The third argument is the levels from the root record, where the root is level 1.  This is used to reference into the receivers preMadeRecords, a performance optimization."
	guard critical: 
		[ | level startingEntryIndex |
		(level := self selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger) isNil ifTrue: [ ^ self ].
		"For inverted records, it is possible the entryIndex for keyInteger will be consumed by the next lower key.  Unfortunately, we have to check."
		startingEntryIndex := record slotIndexFor: keyInteger.
		(record keyAtSlotIndex: startingEntryIndex) < keyInteger ifTrue: [ startingEntryIndex := startingEntryIndex + 1 ].
		self 
			traverseSlotsFromRecord: record
			index: startingEntryIndex
			do: threeArgBlock
			until: conditionBlock
			level: level ]! !

!MaHashIndex methodsFor: 'enumerating' stamp: 'cmm 6/12/2006 22:46'!
slotsFromIndex: globalIndex do: threeArgBlock until: conditionBlock 
	"The first two arguments of threeArgBlock and conditionBlock are the record and the internal index position needed to access the of each entry in those records via keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.  The third argument is the levels from the root record, where the root is level 1.  This is used to reference into the receivers preMadeRecords, a performance optimization."
	guard critical: 
		[ | byteArrayIndexAndLevelArray |
		(byteArrayIndexAndLevelArray := self selectRecordAt: globalIndex) isNil ifTrue: [ ^ self ].
		self 
			traverseSlotsFromRecord: record
			index: (record slotIndexForBax: byteArrayIndexAndLevelArray first)
			do: threeArgBlock
			until: conditionBlock
			level: byteArrayIndexAndLevelArray last ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/29/2002 22:46'!
traverseSlotsFromParentRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| conditionMet |

	conditionMet := false.
	aMaHashIndexRecord
		byteArrayIndexesFrom: entryIndex
		do:
			[ :index | | nextToRead |
			conditionMet
				ifFalse:
					[ nextToRead := aMaHashIndexRecord recordNumberAtByteArrayIndex: index.
					(conditionBlock
						value: aMaHashIndexRecord
						value: index
						value: levelInteger)
							ifTrue:
								[ conditionMet := true ]
							ifFalse:
								[ threeArgBlock
									value: aMaHashIndexRecord
									value: index
									value: levelInteger ] ].
			conditionMet
				ifFalse:
					[ nextToRead > 0
						ifTrue:
							[ | currentRecord |
							currentRecord := recordFactory recordAtLevel: levelInteger + 1.
							self
								readRecord: currentRecord
								at: nextToRead.
							conditionMet :=
								self
									traverseSlotsFromParentRecord: currentRecord
									index: 0
									do: threeArgBlock
									until: conditionBlock
									level: levelInteger + 1 ] ] ].
	^conditionMet
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/29/2002 22:46'!
traverseSlotsFromRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| done |

	done :=
		self
			traverseSlotsFromParentRecord: aMaHashIndexRecord
			index: entryIndex
			do: threeArgBlock
			until: conditionBlock
			level: levelInteger.
	(done not and: [ levelInteger > 1 ])
		ifTrue:
			[ | nextStart |
			nextStart := recordFactory recordAtLevel: levelInteger - 1.
			self
				readRecord: nextStart
				at: (recordFactory recordNumberAtLevel: levelInteger - 1).
			self
				traverseSlotsFromRecord: nextStart
				index: (recordFactory entryIndexAtLevel: levelInteger - 1) + 1
				do: threeArgBlock
				until: conditionBlock
				level: levelInteger - 1 ]
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 4/17/2005 22:13'!
upTo: countInteger at: keyInteger

	^ self
		upTo: countInteger
		keysAndValuesFrom: keyInteger
		to: keyInteger
		startingAt: 1! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 11/16/2007 16:36'!
upTo: countInteger keysAndValuesFrom: lowKey to: highKey startingAt: index 
	"Answer the specified number of values starting at logical-position index *within* the lowKey to highKey range."
	^ guard critical: 
		[ | answerIndex keys values |
		answerIndex := 0.
		keys := Array new: countInteger.
		values := Array new: countInteger.
		self 
			upTo: countInteger
			keysAndValuesFrom: lowKey
			to: highKey
			startingAt: index
			do: 
				[ : eachKey : eachValue | 
				keys 
					at: (answerIndex := answerIndex + 1)
					put: eachKey.
				values 
					at: answerIndex
					put: eachValue ].
		answerIndex = 0 
			ifTrue: 
				[ {  #(). #()  } ]
			ifFalse: 
				[ answerIndex < countInteger 
					ifTrue: 
						[ { 
							(keys 
								copyFrom: 1
								to: answerIndex).
							(values 
								copyFrom: 1
								to: answerIndex)
						 } ]
					ifFalse: 
						[ {  keys. values  } ] ] ]! !

!MaHashIndex methodsFor: 'enumerating' stamp: 'cmm 4/12/2006 21:53'!
upTo: countInteger keysAndValuesFrom: lowKey to: highKey startingAt: index do: twoArgBlock
	"Answer the specified number of values starting at logical-position index within the lowKey to highKey range, value twoArgBlock with each key-value pair in that range."
	| lowest currentIndex |
	currentIndex := 0.
	lowest := self indexOfLowest: lowKey exactKey: false.
	lowest > 0
		ifTrue:
			[ self
				entriesFromIndex: lowest + index - 1
				do:
					[ : currentRecord : byteArrayIndex : level |
					currentIndex := currentIndex + 1.
					twoArgBlock
						value: (currentRecord keyAtByteArrayIndex: byteArrayIndex)
						value: (currentRecord valueAtByteArrayIndex: byteArrayIndex) ]
				until:
					[  : currentRecord : byteArrayIndex : level |
					currentIndex = countInteger
					or: [ (currentRecord keyAtByteArrayIndex: byteArrayIndex) > highKey ] ] ]! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 11/16/2007 16:36'!
upTo: countInteger keysAndValuesFromIndex: lowIndex 
	^ guard critical: 
		[ | answerIndex keys values |
		keys := Array new: countInteger.
		values := Array new: countInteger.
		answerIndex := 0.
		self 
			entriesFromIndex: lowIndex
			do: 
				[ : currentRecord : byteArrayIndex : level | 
				keys 
					at: (answerIndex := answerIndex + 1)
					put: (currentRecord keyAtByteArrayIndex: byteArrayIndex).
				values 
					at: answerIndex
					put: (currentRecord valueAtByteArrayIndex: byteArrayIndex) ]
			until: [ : currentRecord : index : level | answerIndex = countInteger ].
		answerIndex = 0 
			ifTrue: 
				[ {  #(). #()  } ]
			ifFalse: 
				[ answerIndex < countInteger 
					ifTrue: 
						[ { 
							(keys 
								copyFrom: 1
								to: answerIndex).
							(values 
								copyFrom: 1
								to: answerIndex)
						 } ]
					ifFalse: 
						[ {  keys. values  } ] ] ]! !

!MaHashIndex methodsFor: 'SUnit tests' stamp: 'cmm 11/16/2007 16:36'!
upTo: countInteger keysFrom: startKey 
	guard critical: 
		[ | result answerIndex |
		result := Array new: countInteger.
		answerIndex := 1.
		self 
			entriesFrom: startKey
			do: 
				[ : currentRecord : index : level | 
				(currentRecord hasEntryAtByteArrayIndex: index) ifTrue: 
					[ result 
						at: answerIndex
						put: (currentRecord keyAtByteArrayIndex: index).
					answerIndex := answerIndex + 1 ] ]
			until: [ : currentRecord : index : level | answerIndex > countInteger ].
		"Need to check in case of a small index (say only 9 entries?)."
		^ answerIndex < countInteger 
			ifTrue: 
				[ result 
					copyFrom: 1
					to: answerIndex - 1 ]
			ifFalse: [ result ] ]! !

!MaHashIndex methodsFor: 'private' stamp: ''!
writeNewRoot

	self writeRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
writeRecord

	self writeRecord: record
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 3/20/2007 21:30'!
writeRecord: aMaHashIndexRecord 
	broker 
		writeFrom: aMaHashIndexRecord byteArray
		at: aMaHashIndexRecord recordNumber! !

!MaMagnitudeIndex methodsFor: 'building' stamp: ''!
add: oidInteger at: keyInteger

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: 'cmm 3/20/2005 17:50'!
highestPossibleKey

	^ highestPossibleKey ifNil:
		[ highestPossibleKey := (2 raisedTo: keySize) - 1 ]
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: 'cmm 5/23/2005 23:13'!
initialize
	super initialize.
	nextRecordNumber := 0! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
keySize

	^keySize! !

!MaMagnitudeIndex methodsFor: 'private' stamp: ''!
keySize: numberOfBitsInteger

	keySize := numberOfBitsInteger
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
lowestPossibleKey

	^0
! !

!MaMagnitudeIndex methodsFor: 'private' stamp: 'cmm 8/22/2005 09:24'!
open: aReadWriteStream

	super open: aReadWriteStream.
	nextRecordNumber := broker nextRecordNumber.
	nextRecordNumber isInteger
		ifFalse:
			[ MaSpecialCollectionsSoftwareError signal: 'Invalid index size.  Requires maintenance tool.' ]! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
recordSize

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'framework' stamp: 'cmm 12/23/2002 22:16'!
size

	self subclassResponsibility! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: 'cmm 4/28/2005 21:12'!
valueSize

	^ valueSize! !

MaObject subclass: #MaRecordBroker
	instanceVariableNames: 'headerSize recordSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Records'!

!MaRecordBroker commentStamp: 'cmm 5/18/2005 09:46' prior: 0!
I am an abstract superclass for record-based collections such as MaHashIndex and MaLargeArrayOfNumbers.  By plugging them with my appropriate subclass, they are able to be file-based or in-memory (or maybe remote network location in the future).

I don't actually deal with the records themselves, just their reading and writing to the storage.!

MaRecordBroker subclass: #MaFileRecordBroker
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Records'!

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 5/17/2005 23:32'!
close

	file ifNotNil: [ file closed ifFalse: [ file close ] ]! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 6/13/2005 23:22'!
create: aFileStream

	file := aFileStream ifNil: [ ReadWriteStream on: (ByteArray new: 1000) ]! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 5/18/2005 13:30'!
delete

	self close.
	(FileDirectory forFileName: file name) deleteFileNamed: file name! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 5/18/2005 14:30'!
filePositionFor: recordIndex

	^ recordIndex * recordSize + headerSize! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 5/30/2006 08:49'!
filename

	^ file filename! !

!MaFileRecordBroker methodsFor: 'overriding' stamp: 'cmm 5/23/2005 14:11'!
nextRecordNumber

	^ (file size - self headerSize) / recordSize! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 6/14/2005 10:31'!
open: aReadWriteStream

	file := aReadWriteStream! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 5/17/2005 23:28'!
readHeaderInto: aByteArray

	file
		maRead: self headerSize
		bytesFromPosition: 1
		of: aByteArray
		atFilePosition: 0! !

!MaFileRecordBroker methodsFor: 'record' stamp: 'cmm 3/20/2007 21:49'!
readInto: aByteArray at: recordIndex 
	file 
		maRead: recordSize
		bytesFromPosition: 1
		of: aByteArray
		atFilePosition: (self filePositionFor: recordIndex)! !

!MaFileRecordBroker methodsFor: 'overriding' stamp: 'cmm 5/23/2005 14:12'!
size

	^ self nextRecordNumber! !

!MaFileRecordBroker methodsFor: 'record' stamp: 'cmm 3/20/2007 21:47'!
writeFrom: aByteArray at: recordIndex 
	file 
		maWrite: recordSize
		bytesFromPosition: 1
		of: aByteArray
		atFilePosition: (self filePositionFor: recordIndex)! !

!MaFileRecordBroker methodsFor: 'file-specific' stamp: 'cmm 7/11/2005 09:03'!
writeHeaderFrom: aByteArray

	file
		maWrite: self headerSize
		bytesFromPosition: 1
		of: aByteArray
		atFilePosition: 0! !

MaRecordBroker subclass: #MaInImageRecordBroker
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Records'!

!MaInImageRecordBroker methodsFor: 'initialize' stamp: 'cmm 5/23/2005 17:22'!
initialize

	super initialize.
	records := OrderedCollection new! !

!MaInImageRecordBroker methodsFor: 'initialize' stamp: 'cmm 5/23/2005 14:34'!
nextRecordNumber

	^ records size! !

!MaInImageRecordBroker methodsFor: 'overriding' stamp: 'cmm 4/5/2007 00:20'!
readInto: aByteArray at: recordIndex 
	"Since records can be 0-based (sigh), we +1 the recordIndex."
	aByteArray 
		replaceFrom: 1
		to: aByteArray size
		with: (records at: recordIndex + 1)
		startingAt: 1! !

!MaInImageRecordBroker methodsFor: 'overriding' stamp: 'cmm 4/8/2007 18:42'!
writeFrom: aByteArray at: recordIndex 
	[ records size < (recordIndex + 1) ] whileTrue: [ records add: nil ].
	records 
		at: recordIndex + 1
		put: aByteArray copy! !

!MaRecordBroker class methodsFor: 'as yet unclassified' stamp: 'cmm 5/17/2005 23:52'!
headerSize: anInteger

	^ self new
		headerSize: anInteger ;
		yourself! !

!MaRecordBroker methodsFor: 'accessing' stamp: 'cmm 8/12/2007 20:34'!
close
	"File-based will override."! !

!MaRecordBroker methodsFor: 'override' stamp: 'cmm 5/23/2005 14:32'!
delete
	"Do nothing by default."! !

!MaRecordBroker methodsFor: 'accessing' stamp: 'cmm 5/17/2005 23:49'!
headerSize

	^ headerSize! !

!MaRecordBroker methodsFor: 'accessing' stamp: 'cmm 5/17/2005 23:49'!
headerSize: anInteger

	headerSize := anInteger! !

!MaRecordBroker methodsFor: 'override' stamp: 'cmm 5/17/2005 23:01'!
nextRecordNumber

	self subclassResponsibility ! !

!MaRecordBroker methodsFor: 'override' stamp: 'cmm 8/14/2007 22:37'!
open: fileNameString
	"Only the MaFileRecordBroker needs to do anything."! !

!MaRecordBroker methodsFor: 'override' stamp: 'cmm 5/23/2005 22:50'!
readInto: aMaFixedLengthRecord at: recordIndex

	self subclassResponsibility! !

!MaRecordBroker methodsFor: 'accessing' stamp: 'cmm 5/22/2005 21:15'!
recordSize

	^ recordSize! !

!MaRecordBroker methodsFor: 'accessing' stamp: 'cmm 5/22/2005 21:15'!
recordSize: anInteger

	recordSize := anInteger! !

!MaRecordBroker methodsFor: 'override' stamp: 'cmm 3/20/2007 22:27'!
writeFrom: aByteArray at: recordIndex 
	self subclassResponsibility! !

MaObject subclass: #MaTree
	instanceVariableNames: 'parents children sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Tree'!

MaTree subclass: #MaIdentityTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Tree'!

!MaIdentityTree methodsFor: 'private' stamp: 'cmm 4/13/2007 13:41'!
childrenClass
	^ IdentityDictionary! !

!MaIdentityTree methodsFor: 'private' stamp: 'cmm 4/13/2007 13:39'!
parentsClass
	^ IdentityDictionary! !

!MaIdentityTree methodsFor: 'private' stamp: 'cmm 4/13/2007 13:53'!
removeFromChildren: anObject 
	"There is no removeIdentical:, so I just did it this way.."
	(children at: (self parentOf: anObject)) removeAllSuchThat: [ : each | each == anObject ]! !

!MaTree methodsFor: 'building' stamp: ''!
add: anObject
	"Adds anObject as a main parent in the receiver."

	self
		add: anObject
		asChildOf: nil.
	^anObject
! !

!MaTree methodsFor: 'building' stamp: 'cmm 4/13/2007 16:05'!
add: anObject asChildOf: aParentObject 
	parents 
		at: anObject
		put: aParentObject.
	(children 
		at: aParentObject
		ifAbsentPut: [ self newChildCollection ]) in: [ : immediateChildren | (immediateChildren includes: anObject) ifFalse: [ immediateChildren add: anObject ] ].
	children 
		at: anObject
		ifAbsentPut: [ self newChildCollection ].
	^ anObject! !

!MaTree methodsFor: 'building' stamp: 'cmm 2/23/2007 16:00'!
addAll: aCollection 
	"Adds all in aCollection as main parents in the receiver."
	aCollection do: [ : each | self add: each ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/22/2007 12:25'!
anyOne
	^ self roots anyOne! !

!MaTree methodsFor: 'converting' stamp: 'cmm 2/23/2007 15:21'!
asSet
	"Answer a Set of all the members of this tree."
	^ parents keys! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 4/11/2007 17:37'!
breadthFirstDo: oneArgBlock
	self 
		breadthFirstDo: oneArgBlock
		at: nil! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 4/12/2007 10:45'!
breadthFirstDo: oneArgBlock at: nodeObject 
	self 
		breadthFirstDo: oneArgBlock
		atAll: {nodeObject}
		path: OrderedCollection new! !

!MaTree methodsFor: 'private' stamp: 'cmm 4/12/2007 13:10'!
breadthFirstDo: oneArgBlock atAll: nodes path: path 
	nodes do: [ : each | 
		each ifNotNil: 
			[ path addLast: each.
			oneArgBlock value: path ] ].
	nodes ifNotEmpty: 
		[ self 
			breadthFirstDo: oneArgBlock
			atAll: (nodes 
					inject: OrderedCollection new
					into: 
						[ : coll : each | 
						coll
							addAll: (self childrenOf: each) ;
							yourself ])
			path: path ].
	path removeLast! !

!MaTree methodsFor: 'private' stamp: 'cmm 12/21/2007 15:02'!
childrenClass
	^ (Smalltalk hasClassNamed: #MaDictionary) 
		ifTrue: [ Smalltalk classNamed: #MaDictionary ]
		ifFalse: [ Dictionary ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 4/11/2007 17:19'!
childrenOf: anObject 
	^ children at: anObject! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 12/21/2007 09:53'!
collect: aBlock
	"Returns a new tree whose nodes have all been operated on by aBlock."
	^self
		collect: aBlock
		into: self maOriginalClass new! !

!MaTree methodsFor: 'private' stamp: 'cmm 2/23/2007 17:12'!
collect: aBlock into: aMaTree 
	"Since some objects may share a parent, we use the map to make sure we only value each parent just once, so an identical version of that object is kept."
	| map |
	map := IdentityDictionary new.
	self withParentsDo: 
		[ : eachChild : eachParent | 
		eachParent isNil 
			ifTrue: 
				[ aMaTree add:
					(map 
						at: eachChild
						ifAbsentPut: [ aBlock value: eachChild ]) ]
			ifFalse: 
				[ aMaTree 
					add: 
						(map 
							at: eachChild
							ifAbsentPut: [ aBlock value: eachChild ])
					asChildOf: 
						(map 
							at: eachParent
							ifAbsentPut: [ aBlock value: eachParent ]) ] ].
	^ aMaTree! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/21/2007 12:55'!
depthFirstDo: oneArgBlock 
	"Value oneArgBlock with the path of objects in the receiver from each main parent in the order of depthFirst."
	self 
		depthFirstDo: oneArgBlock
		at: nil! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/21/2007 12:54'!
depthFirstDo: oneArgBlock at: anObject 
	self 
		depthFirstDo: oneArgBlock
		at: anObject
		path: OrderedCollection new! !

!MaTree methodsFor: 'private' stamp: 'cmm 3/21/2007 12:03'!
depthFirstDo: oneArgBlock at: anObject path: path 
	anObject ifNotNil: 
		[ path addLast: anObject.
		oneArgBlock value: path ].
	(self childrenOf: anObject) do: 
		[ : each | 
		self 
			depthFirstDo: oneArgBlock
			at: each
			path: path ].
	anObject ifNotNil: [ path removeLast ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 16:05'!
depthOf: anObject 
	"Returns the number of parents anObject has."
	| depth |
	depth := -1.
	self 
		pathFrom: anObject
		to: nil
		do: [ : eachInPath | depth := depth + 1 ].
	^ depth! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:04'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:03'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [ : each | (aBlock value: each) ifTrue: [ ^ each ] ].
	^ exceptionBlock value! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 12/24/2002 16:07'!
do: oneArgBlock

	parents keysDo: oneArgBlock! !

!MaTree methodsFor: 'private' stamp: 'cmm 2/23/2007 16:04'!
errorNotFound: anObject
	"Actually, this should raise a special Exception not just an error."

	self error: 'Object is not in the collection.'! !

!MaTree methodsFor: 'testing' stamp: 'cmm 4/12/2007 13:31'!
hasChildFor: anObject 
	"Returns true if anObject has any children.  Signal an error if anObject is not part of the hierarchy."
	^ parents includes: anObject! !

!MaTree methodsFor: 'testing' stamp: 'cmm 2/23/2007 16:16'!
hasParentFor: anObject 
	"Returns true if anObject has a parent.  Signal an error if anObject is not part of the hierarchy."
	^ (self parentOf: anObject) notNil! !

!MaTree methodsFor: 'testing' stamp: 'cmm 2/23/2007 17:59'!
ifEmpty: aBlock
	"Evaluate the block if I'm empty"

	^ self isEmpty ifTrue: aBlock! !

!MaTree methodsFor: 'testing' stamp: ''!
includes: anObject 
	^parents includesKey: anObject! !

!MaTree methodsFor: 'private' stamp: 'cmm 4/13/2007 16:07'!
initialize
	super initialize.
	parents := self parentsClass new.
	children := self childrenClass new
		at: nil
			put: self newChildCollection ;
		yourself! !

!MaTree methodsFor: 'testing' stamp: 'cmm 2/23/2007 17:59'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:04'!
maDetect: aBlock ifFound: foundBlock ifNone: exceptionBlock 
	"foundBlock takes one argument, the found object."

	self 
		do: [ :element | (aBlock value: element) ifTrue: [ ^foundBlock value: element ] ].
	^exceptionBlock value
! !

!MaTree methodsFor: 'printing' stamp: 'cmm 4/12/2007 16:58'!
maPrintAbbreviatedOn: aStream
	super maPrintAbbreviatedOn: aStream.
	self depthFirstDo:
		[ : path |
		aStream
			cr;
			tab: path size - 1 ;
			maPrint: path last ]! !

!MaTree methodsFor: 'building' stamp: 'cmm 2/23/2007 16:11'!
mergePath: anOrderedCollection 
	"Adds each object in anOrderedCollection as a new path in
	the receiver.  The first element in anOrderedCollection is the
	main parent, and each subsequent element is a child of the
	previous.  Any parts of the path that need created will be."
	^ self 
		mergePath: anOrderedCollection
		to: nil! !

!MaTree methodsFor: 'building' stamp: 'cmm 2/23/2007 16:11'!
mergePath: anOrderedCollection to: parentObject 
	"Adds each object in anOrderedCollection as a new path in the receiver.  The first element in anOrderedCollection is added as a child of parentObject, and each subsequent element is a child of the previous.  Whereever part of the path already exists, it is reused."
	parentObject ifNotNil: [ self verifyIncludes: parentObject ].
	anOrderedCollection 
		inject: parentObject
		into: 
			[ : parent : each | 
			self 
				add: each
				asChildOf: parent.
			each ].
	^ anOrderedCollection! !

!MaTree methodsFor: 'building' stamp: 'cmm 2/23/2007 16:12'!
mergeTree: aMaTree 
	^ self 
		mergeTree: aMaTree
		at: nil! !

!MaTree methodsFor: 'building' stamp: 'cmm 2/23/2007 16:12'!
mergeTree: aMaTree at: anObject 
	self verifyIncludes: anObject.
	aMaTree withParentsDo: 
		[ : each : eachParent | 
		self 
			add: each
			asChildOf: eachParent ].
	^ aMaTree! !

!MaTree methodsFor: 'building' stamp: 'cmm 4/11/2007 17:20'!
move: anObject to: newParentObject 
	^ self 
		add: anObject
		asChildOf: newParentObject! !

!MaTree methodsFor: 'private' stamp: 'cmm 4/13/2007 16:09'!
newChildCollection
	^ sortBlock 
		ifNil: [ OrderedCollection new ]
		ifNotNil: [ SortedCollection sortBlock: sortBlock ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 16:05'!
nodesInPathFrom: someChildObject to: someParentObject 
	"Returns a collection of nodes between someChildObject
	and someParentObject."
	| answer |
	answer := OrderedCollection new.
	self 
		pathFrom: someChildObject
		to: someParentObject
		do: [ : each | answer add: each ].
	^ answer! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 4/12/2007 13:31'!
parentOf: anObject 
	^ parents at: anObject! !

!MaTree methodsFor: 'private' stamp: 'cmm 11/29/2007 09:45'!
parentsClass
	^ MaDictionary! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 15:57'!
pathFrom: anObject 
	"Returns a collection of the objects that are contained in the path to anObject ordered from an Object to the top of the hierarchy."
	^ self 
		nodesInPathFrom: anObject
		to: nil! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:05'!
pathFrom: anObject do: aBlock 
	"Value aBlock with the objects from anObject to its highest level parent."
	self 
		pathFrom: anObject
		to: nil
		do: aBlock! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 4/12/2007 13:31'!
pathFrom: someChildObject to: someParentObject do: oneArgBlock 
	"For each node in the tree from someChildObject to someParentObject, inclusive, value oneArgBlock.  The highest level parent (nil) will not be used as an argument to value oneArgBlock."
	| node |
	someParentObject ifNotNil: [ self verifyIncludes: someParentObject ].
	node := someChildObject.
	[ node isNil or: [ node = someParentObject ] ] whileFalse: 
		[ oneArgBlock value: node.
		node := self parentOf: node ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 15:57'!
pathTo: anObject 
	"Returns a collection of the objects that are contained in the path to anObject, ordered from the the top of the hierarchy to anObject."
	^ (self pathFrom: anObject) reverse! !

!MaTree methodsFor: 'copying' stamp: 'cmm 4/12/2007 13:13'!
postCopy
	"Private - use Copy"
	| newChildren |
	parents := parents copy.
	newChildren := children class new.
	children keysAndValuesDo:
		[ : eachNode : eachChildren |
		newChildren at: eachNode put: eachChildren copy ].
	children := newChildren! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 4/29/2007 13:56'!
reSort
	children do: [ : each | each maIsSortedCollection ifTrue: [ each reSort ] ]! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 12/21/2007 09:54'!
reject: aBlock 
	"Answer the Set of my elements which do not satisfy aBlock."
	| answer |
	answer := self maOriginalClass new.
	self do: [ : each | (aBlock value: each) ifFalse: [ answer add: each ] ].
	^ answer! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:11'!
rejectBranches: aBlock 
	"Returns a new Tree without my branches that satisfy aBlock."
	| newTree |
	newTree := self maOriginalClass new.
	self do: [ : each | (aBlock value: each) ifFalse: [ newTree mergePath: (self pathTo: each) ] ].
	^ newTree! !

!MaTree methodsFor: 'building' stamp: 'cmm 7/25/2002 19:42'!
remove: anObject
	"Removes anObject and all of its children."

	^self
		remove: anObject
		ifAbsent: [ self error: anObject printString, ' was not found in ', self printString ]
! !

!MaTree methodsFor: 'building' stamp: 'cmm 4/13/2007 13:51'!
remove: anObject ifAbsent: aBlock 
	"Answers the tree of removed objects removed after removing anObject after removing it and all of its children."
	| tree |
	(self includes: anObject) ifFalse: [ ^ aBlock value ].
	self removeFromChildren: anObject.
	(tree := self treeAt: anObject) asSet do: 
		[ : each | 
		parents removeKey: each.
		children 
			removeKey: each
			ifAbsent: 
				[ "do nothing"
				 ] ].
	^ tree! !

!MaTree methodsFor: 'private' stamp: 'cmm 4/13/2007 13:52'!
removeFromChildren: anObject 
	(children at: (self parentOf: anObject)) remove: anObject! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 6/10/2003 23:08'!
roots
	"Answers a collection of all roots in this tree."

	^self childrenOf: nil
! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 2/23/2007 16:28'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  Answer a new Set, only those elements for which aBlock evaluates to true."
	| newCollection |
	newCollection := Set new.
	self do: [ : each | (aBlock value: each) ifTrue: [ newCollection add: each ] ].
	^ newCollection! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 12/21/2007 09:48'!
selectPaths: aBlock 
	"Answer a new Tree with just my branches that at least somewhere link nodes that satisfy aBlock.  The argument to aBlock is the path of nodes to the current node."
	| newTree |
	newTree := self maOriginalClass new.
	self depthFirstDo: 
		[ : path | 
		(aBlock value: path) ifTrue: [ newTree mergePath: path ] ].
	^ newTree! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 15:58'!
size
	^ parents size! !

!MaTree methodsFor: 'building' stamp: 'cmm 4/13/2007 16:17'!
sortBlock: aBlock 
	"Specify a two-argument block, aBlock, which describes how children at each level are sorted."
	| newChildren |
	sortBlock := aBlock.
	newChildren := children class new: children size.
	children keysAndValuesDo: 
		[ : eachParent : eachChildren | 
		newChildren 
			at: eachParent
			put: (eachChildren asSortedCollection: sortBlock) ].
	children := newChildren! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 2/23/2007 15:58'!
treeAt: anObject 
	"Return a new instance of the receiver which has a single main parent anObject."
	^ self 
		treeAt: anObject
		ifAbsent: 
			[ self error: anObject printString , ' was not found in ' , self printString ]! !

!MaTree methodsFor: 'accessing' stamp: 'cmm 12/21/2007 09:54'!
treeAt: anObject ifAbsent: aBlock 
	"Return a new instance of the receiver which has a single main parent anObject."
	| newTree |
	(self includes: anObject) ifFalse: [ ^ aBlock value ].
	newTree := self maOriginalClass new.
	self 
		depthFirstDo: 
			[ : path | 
			newTree 
				add: path last
				asChildOf: (path size > 1 ifTrue: [ path at: path size - 1 ]) ]
		at: anObject.
	^ newTree! !

!MaTree methodsFor: 'private' stamp: 'cmm 2/23/2007 15:35'!
verifyIncludes: anObject 
	(self includes: anObject) ifFalse: 
		[ self error: self printString , ' does not include ' , anObject printString ]! !

!MaTree methodsFor: 'enumerating' stamp: 'cmm 12/24/2002 16:09'!
withParentsDo: twoArgBlock

	parents keysAndValuesDo: twoArgBlock! !

WeakValueAssociation weakSubclass: #MaWeakValueAssociation
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaWeakValueAssociation class methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:37'!
key: key value: value next: next
	^ (self basicNew:1) key: key value: value next: next! !

!MaWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:37'!
do: aBlock
	aBlock value: self.
	next ifNotNil: [ next do: aBlock ]! !

!MaWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:37'!
findKeyOrNil: akey
	^ key = akey ifTrue: [ self ] ifFalse: [ next ifNotNil: [next findKeyOrNil: akey ] ]! !

!MaWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/25/2007 18:24'!
key: aKey value: anObject next: aNext
	"Store the arguments as the variables of the receiver."

	key := aKey.
	self value: anObject.
	next := aNext! !

!MaWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:37'!
next
	^ next! !

!MaWeakValueAssociation methodsFor: 'as yet unclassified' stamp: 'sig 7/20/2007 12:37'!
next: aNext
	next := aNext! !

BTree subclass: #WeakValueBTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Collections'!

!WeakValueBTree methodsFor: 'accessing' stamp: 'cmm 3/23/2006 20:37'!
at: key ifAbsent: aBlock
	^ (super
		at: key
		ifAbsent: [ ^ aBlock value ]) at: 1! !

!WeakValueBTree methodsFor: 'accessing' stamp: 'cmm 10/28/2011 15:52'!
at: anObject ifPresent: oneArgBlock ifAbsent: zeroArgBlock 
	| current uniqueObject |
	uniqueObject := String empty.
	^ (current := self
		at: anObject
		ifAbsent: [ uniqueObject ]) == uniqueObject
		ifTrue: [ zeroArgBlock value ]
		ifFalse: [ oneArgBlock value: current ]! !

!WeakValueBTree methodsFor: 'accessing' stamp: 'cmm 3/23/2006 21:26'!
at: key put: anObject
	super
		at: key
		put: (WeakArray with: anObject).
	^ anObject! !

!WeakValueBTree methodsFor: 'accessing' stamp: 'cmm 3/23/2006 19:15'!
copy
	| answer |
	answer := self class new.
	self keysAndValuesDo: 
		[ : eachKey : eachValue | 
		answer 
			at: eachKey 
			put: eachValue ].
	^ answer! !

!WeakValueBTree methodsFor: 'enumerating' stamp: 'cmm 3/23/2006 21:42'!
do: aBlock
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		aBlock value:
			(Association
				key: eachKey
				value: eachValue) ]! !

!WeakValueBTree methodsFor: 'enumerating' stamp: 'cmm 3/23/2006 19:41'!
keysAndValuesDo: aBlock
	super keysAndValuesDo:
		[ : eachKey : eachValue |
		aBlock
			value: eachKey
			value: (eachValue at: 1) ]! !

!WeakValueBTree methodsFor: 'enumerating' stamp: 'cmm 3/23/2006 21:47'!
select: aBlock
	| answer |
	answer := self species new.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		(aBlock value: eachValue) ifTrue: 
			[answer
				at: eachKey
				put: eachValue ] ].
	^ answer! !

TestCase subclass: #MaDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys'!

!MaDictionaryTest commentStamp: '<historical>' prior: 0!
before running tests , use:

MaDictionaryTest initDictClass: MaWeakValueDictionary

MaDictionaryTest initDictClass: MaWeakValueDictionary

tests for WeakKey/WeakIdentityKey dicts will fail (keys must be non nil, and some tests because of identity compatison )!

!MaDictionaryTest methodsFor: 'instantiating dict' stamp: 'Igor.Stasenko 5/12/2010 22:10'!
newDict
	^ MaDictionary new! !

!MaDictionaryTest methodsFor: 'tests' stamp: 'Igor.Stasenko 5/12/2010 21:39'!
testAdd
	
	| dict |
	dict := self newDict.
	dict add: #a -> 1.
	dict add: #b -> 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2! !

!MaDictionaryTest methodsFor: 'tests' stamp: 'Igor.Stasenko 5/12/2010 21:39'!
testAddAll
	
	| dict1 dict2 |
	dict1 := self newDict.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := self newDict.
	dict2 at: #a put: 3 ; at: #c put: 4.
	dict1 addAll: dict2.
	self assert: (dict1 at: #a) = 3.
	self assert: (dict1 at: #b) = 2.
	self assert: (dict1 at: #c) = 4.! !

!MaDictionaryTest methodsFor: 'association tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAddAssociation
	"self run:#testAddAssociation"
	"self debug:#testAddAssociation"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2.
	
	dict at: #a put: 10.
	dict at: #c put: 2.
	
	self assert: (dict at: #a) = 10.
	self assert: (dict at: #b) = 2.
	self assert: (dict at: #c) = 2
	
	! !

!MaDictionaryTest methodsFor: 'association tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAssociationsSelect
	| answer d |
	d := self newDict.
	d at: (Array with: #hello with: #world)
	  put: #fooBar.
	d at: Smalltalk put: #'Smalltalk is the key'.
	d at: #Smalltalk put: Smalltalk.
	answer := d
				associationsSelect: [:assoc | assoc key == #Smalltalk
						and: [assoc value == Smalltalk]].
	self
		should: [answer isKindOf: MaDictionary].
	self
		should: [answer size == 1].
	self
		should: [(answer at: #Smalltalk)
				== Smalltalk].
	answer := d
				associationsSelect: [:assoc | assoc key == #NoSuchKey
						and: [assoc value == #NoSuchValue]].
	self
		should: [answer isKindOf: MaDictionary].
	self
		should: [answer size == 0]! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAtError
	"self run: #testAtError"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 666.
	self shouldnt: [ dict at: #a ] raise: Error.
	self should: [ dict at: #b ] raise: Error.
	
	! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAtIfAbsent
	"self run: #testAtIfAbsent"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 666.
	
	self assert: (dict at: #a ifAbsent: [nil]) = 666.
	
	self assert: (dict at: #b ifAbsent: [nil]) isNil.

	! !

!MaDictionaryTest methodsFor: 'implementation tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testAtNil
	"(self run: #testAtNil)"
	"nil is a valid key in squeak. In VW nil is not a valid key"
	"Ansi 1.9 p, 168
    		5.7.2.5 Message: at: key put: newElement
    		Synopsis
    			Store newElement at key in the receiver. Answer newElement.
    		Definition: <abstractDictionary>
    		If lookup succeeds for key, then newElement replaces the element previously stored at key.
    		Otherwise, the newElement is stored at the new key. In either case, subsequent successful
    		lookups for key will answer newElement.  Answer newElement.

    		The result is undefined if the key is nil.

		This clearly indicates that different smalltalks where doing different assumptions."
	
	
	
	| dict1  |
	dict1 := self newDict.
	self shouldnt: [ dict1 at: nil put: #none] raise: Error.
	self assert: (dict1 at: nil) = #none. 
	! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAtPut
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| adictionary |
	adictionary := self newDict.
	adictionary at: #a put: 3.
	self assert: (adictionary at: #a) = 3.
	adictionary at: #a put: 3.
	adictionary at: #a put: 4.
	self assert: (adictionary at: #a) = 4.
	adictionary at: nil put: 666.
	self assert: (adictionary at: nil) = 666! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testAtPutNil
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| dict |
	dict := self newDict.
	dict at: nil put: 1.
	self assert: (dict at: nil) = 1.
	dict at: #a put: nil.
	self assert: (dict at: #a) = nil.
	dict at: nil put: nil.
	self assert: (dict at: nil) = nil.
	
	
	! !

!MaDictionaryTest methodsFor: 'tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testComma
	
	| dict1 dict2 dict3 |
	dict1 := self newDict.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := self newDict.
	dict2 at: #a put: 3 ; at: #c put: 4.
	dict3 := dict1, dict2.
	self assert: (dict3 at: #a) = 3.
	self assert: (dict3 at: #b) = 2.
	self assert: (dict3 at: #c) = 4.! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 11/8/2010 00:37'!
testCopy

	"self run:#testKeys "
	
	| dict dict2 | 
	dict := self newDict.
	dict at: 1 put: 1.
	dict at: 2 put: 2.
	dict at: 3 put: 3.
	dict at: 4 put: 4.

	dict2 := dict copy.
	dict2 associationsDo: [:each | self assert: (dict at: each key) = each value ].
	self assert: dict size= dict2 size.

	! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testDictionaryConcatenation
	"self run: #testDictionaryConcatenation"
	
	
	| dict1 dict2 dict3 |
	dict1 := self newDict.
	dict1 at: #a put: 'Nicolas' ; at: #b put: 'Damien'. 
	
	dict2 := self newDict.
	dict2 at: #a put: 'Christophe' ; at: #c put: 'Anthony'.
	dict3 := dict1, dict2.
	
	self assert: (dict3 at: #a) = 'Christophe'.
	self assert: (dict3 at: #b) = 'Damien'.
	self assert: (dict3 at: #c) = 'Anthony'.
	

	! !

!MaDictionaryTest methodsFor: 'association tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testIncludesAssociation
	"self run:#testIncludesAssociation"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict includesAssociation: (#a -> 1)).
	self assert: (dict includesAssociation: (#b -> 2)).
	
	! !

!MaDictionaryTest methodsFor: 'association tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testIncludesAssociationNoValue
	"self run:#testIncludesAssociationNoValue"
	"self debug:#testIncludesAssociationNoValue"
	
	| dict a1 a3 |
	a1 := Association key: #Italie.
	a3 := Association key: #France value: 'Paris'.
	
	self assert: (a1 key = #Italie).
	self assert: (a1 value isNil).
	
	dict := self newDict.
	dict add: a1.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: #Italie).
	self assert: (dict at: #Italie) isNil.
	self assert: (dict at: #France) = 'Paris'

	
	
	! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testIncludesKey
	"self run:#testIncludesKey"
	"self debug:#testIncludesKey"
	
	| dict a1 a2 a3 |
	a1 := Association key: 'Italie'.
	a2 := Association new.
	a3 := Association key: 'France' value: 'Paris'.
	
	dict := self newDict.
	dict add: a1 .
	dict add: a2.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: 'France').
	self assert: (dict includesKey: #Italie).
	self assert: (dict includesKey: nil).	
		
	self assert: (dict at: 'France' ) = 'Paris'.
! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testKeyAtValue
	"self run: #testKeyAtValue"
	"self debug: #testKeyAtValue"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	
	self assert: (dict keyAtValue: 2) = #b.
	self assert: (dict keyAtValue: 1) = #c.
	"ugly may be a bug, why not having a set #a and #c"
	
	self should: [dict keyAtValue: 0] raise: Error
	
	
! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testKeys

	"self run:#testKeys "
	
	| a1 a2  dict | 
	a1 := Association key: 'France' value: 'Paris'.
	a2 := Association key: 'Italie' value: 'Rome'.
	dict := self newDict.
	dict add: a1.
	dict add: a2.
	 		
	self assert: (dict keys size) = 2.
	
	self assert: (dict keys includes: #France)
	
	


	
	! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testKeysDo
	"self run: #testKeysDo"
	"self debug: #testKeysDo"
	
	| dict res |
	dict := self newDict.
	
	dict at: #a put: 33.
	dict at: #b put: 66.
	
	res := OrderedCollection new.
	dict keysDo: [ :each | res add: each].
	
	self assert: res asSet = #(a b) asSet.


	
	! !

!MaDictionaryTest methodsFor: 'basic tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testOccurrencesOf
	"self run:#testOccurrencesOf"
	
	| dict |
	dict := self newDict.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	dict at: #d put: 3.
	dict at: nil put: nil.
	dict at: #z put: nil.
	
	
	self assert: (dict occurrencesOf: 1 ) = 2.
	self assert: (dict occurrencesOf: nil ) = 2.
	
	
	
	! !

!MaDictionaryTest methodsFor: 'tests' stamp: 'Igor.Stasenko 5/12/2010 21:40'!
testPseudo
	"(self run: #testPseudo)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := self newDict.
	self shouldnt: [dict1 at: true put: #true] raise: Error.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: Error.
	self assert: (dict1 at: false) = #false.! !

!MaDictionaryTest methodsFor: 'implementation tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testPseudoVariablesAreValidKeys
	"(self run: #testPseudoVariablesAreValidKeys)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := self newDict.
	self shouldnt: [dict1 at: true put: #true] raise: Error.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: Error.
	self assert: (dict1 at: false) = #false.! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:41'!
testRemoveKey
		"self run:#testRemoveKey "

	| dict | 
	dict := self newDict.
	dict at: #a put: 1.
	dict at: #b put: 2.
	 
	self assert: (dict keys size) = 2.
	dict removeKey: #a.
	self assert: dict keys size  = 1.

	self should: [dict at: #a] raise: Error.
	self assert: (dict at: #b) = 2


	
	! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'Igor.Stasenko 5/12/2010 21:42'!
testValues
	"self run:#testValues "
	
	| a1 a2 a3 dict | 
	a1 := Association key: 'France' value: 'Paris'.
	a2 := Association key: 'Italie' value: 'Rome'.
	dict := self newDict.
	dict add: a1.
	dict add: a2.
	 
	self assert: (dict values size ) = 2.
	self assert: (dict values includes: 'Paris').
	
	a3 := Association new.
	dict add: a3.
	self assert: (dict values size ) = 3.
	self assert: (dict values includes: nil).
	
	
	
	
	
	


	
	! !

!MaDictionaryTest methodsFor: 'weak keys' stamp: 'Igor.Stasenko 11/8/2010 00:33'!
testWeakIdentityKeys
	self weakIdentityKeysTestFor: self weakIdentityKeyClass.
"	self weakIdentityKeysTestFor: WeakIdentityKeyDictionary."
! !

!MaDictionaryTest methodsFor: 'weak keys' stamp: 'Igor.Stasenko 11/8/2010 00:29'!
testWeakKeys
	self weakKeysTestFor: self weakKeyClass
"	self weakKeysTestFor: WeakKeyDictionary."
! !

!MaDictionaryTest methodsFor: 'keys and value tests' stamp: 'sig 8/21/2007 23:03'!
testWeakReject

	"self run:#testKeys "
	
	| dict dict2 | 
	dict := MaWeakValueDictionary new.
	dict at: 1 put: 2.
	dict at: 2 put: 3.
	dict at: 3 put: nil.
	dict at: 4 put: 5.

	dict2 := dict reject: [:each | each isNil ].	! !

!MaDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 11/8/2010 00:39'!
weakIdentityKeyClass
	^ MaWeakIdentityKeyDictionary ! !

!MaDictionaryTest methodsFor: 'weak keys' stamp: 'cmm 12/22/2010 15:02'!
weakIdentityKeysTestFor: aClass
	| d k1 k2 |
	d := aClass new.

	k1 := 'x' copy.
	k2 := k1 copy.

	d at: k1 put: 1.
	d at: k2 put: 2.

	self assert:  (d at: k1) == 1 .
	self assert:  (d at: k2) == 2 .

	d at: k1 put: k2.
	k1 := nil.
	k2 := nil.
	Smalltalk garbageCollect.
	self assert:  d size = 2 .
	self assert:  (d includesKey: nil) not.
	self assert: ( d values includes: 2).
	self assert: ( d values includes: 1) not.
	d primFinalizeValues.
	self assert: d size = 1 .
	Smalltalk garbageCollect.
	d primFinalizeValues.
	self assert:  d size = 0 .! !

!MaDictionaryTest methodsFor: 'weak keys' stamp: 'Igor.Stasenko 11/8/2010 00:29'!
weakKeyClass
	^ MaWeakKeyDictionary.
! !

!MaDictionaryTest methodsFor: 'weak keys' stamp: 'cmm 12/22/2010 15:01'!
weakKeysTestFor: aClass
	| d anotherInstance |
	d := aClass new.
	anotherInstance := 'x' copy.

	d at: 'x' copy put: 'yyy'.
	d at: 'y' put: #zzz.
	Smalltalk garbageCollect.
	self assert:  (d includesKey: 'x') not .
	self assert:  (d at: 'y') = #zzz .
	self assert:  (d includesKey: nil ) not .
	self assert:  d size = 2 .

	d primFinalizeValues.
	self assert: d size = 1 .
	self assert: (d at: 'y') = #zzz.

	self assert:  (d at: nil put: 'kkk') = 'kkk' .
	self assert:  (d includesKey: nil ) not .! !

MaDictionaryTest subclass: #MaIdentityKeyWeakValueDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto-Tests'!

!MaIdentityKeyWeakValueDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 22:42'!
newDict

	^ MaAutoIdentityKeyWeakValueDictionary new! !

MaDictionaryTest subclass: #MaWeakIdentityKeyDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto-Tests'!

!MaWeakIdentityKeyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 11/8/2010 00:38'!
expectedFailures
	"identity key dictionary behaves differently, so, testIncludesKey is non fit"
	^ #( testIncludesKey)! !

!MaWeakIdentityKeyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:25'!
newDict

	^ MaAutoWeakIdentityKeyDictionary new! !

!MaWeakIdentityKeyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 11/8/2010 00:34'!
weakIdentityKeyClass
	^ MaAutoWeakIdentityKeyDictionary! !

!MaWeakIdentityKeyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 11/8/2010 00:34'!
weakKeyClass

	^ MaAutoWeakKeyDictionary! !

MaDictionaryTest subclass: #MaWeakKeyDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto-Tests'!

!MaWeakKeyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:25'!
newDict

	^ MaAutoWeakKeyDictionary new! !

MaDictionaryTest subclass: #MaWeakValueDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Dictionarys-Auto-Tests'!

!MaWeakValueDictionaryTest methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/12/2010 21:25'!
newDict

	^ MaAutoWeakValueDictionary new! !

TestCase subclass: #MaHashIndexRecordTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Tests'!

!MaHashIndexRecordTester methodsFor: 'overriding' stamp: 'cmm 2/11/2011 16:20'!
defaultTimeout
"Timeouts on tests, ain't it great?!!"
	^ 99 days asSeconds! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 7/26/2012 20:16'!
notify: aString
	Transcript cr; show: aString! !

!MaHashIndexRecordTester methodsFor: 'tests' stamp: 'cmm 8/17/2005 19:42'!
testAll
	"Test a variety of keySize and recordSize combinations.  For each pair, run only as far as it takes to get two-deep into duplicates for all originating from one entry in the root record, chosen at random."

	| testCount |
	testCount := 0.
	#(16 24 32 40 56 64 96 128 160 192 256) "keySizes" do:
		[ : keySize |
		#(2 4 8 16 32 64 128) "recordSizes" do:
			[ : recordSize |  | startRecord  |
			"make test run-time reasonable by skipping enough levels to only test the bottom 100000 records or so."
			startRecord := 
				self
					zoomedRecord: keySize 
					recordSize: recordSize 
					childSpace: 10000.
			self notify: 'testing keySize: ', keySize printString, ' recordSize: ', recordSize printString, ', total key span: ', (startRecord highKey - startRecord lowKey) printString.
			self 
				verifyRecord: startRecord					
				do:
					[ : record : eachBax |
					record == startRecord
						ifTrue:
							[ self notify:
								(String streamContents:
									[ : stream |
									stream
										tab; maPrint: 'x:' ;
										maPrint: (record slotIndexForBax: eachBax) ;
										maPrint: ' (~' ;
										maPrint: testCount ;
										maPrint: ' records tested)' ]) ].
					testCount := testCount + 1 ] ] ]! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 7/1/2005 16:53'!
verifyConsecutiveContiguousKeyRangesOn: aMaHashIndexRecord

	0
		to: aMaHashIndexRecord numberOfSlots - 2
		do:
			[ : index |
			self should:
				[ aMaHashIndexRecord canHoldDuplicateKeys
					ifTrue:
						[ ((aMaHashIndexRecord lowestKeyAtIndex: index + 1) -
							(aMaHashIndexRecord highestKeyAtIndex: index))
								between: 0
								and: 1 ]
					ifFalse:
						[ ((aMaHashIndexRecord lowestKeyAtIndex: index + 1) -
							(aMaHashIndexRecord highestKeyAtIndex: index)) = 1 ] ] ]! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 7/1/2005 17:12'!
verifyEntryIndexAndRangeEndpointCongruenceOn: aMaHashIndexRecord

	0
		to: aMaHashIndexRecord numberOfSlots - 1
		do:
			[ : x |  | key |

			key := aMaHashIndexRecord lowestKeyAtIndex: x.
			self should:
				[ x
					between: (aMaHashIndexRecord slotIndexFor: key)
					and: (aMaHashIndexRecord highestSlotIndexFor: key) ].

			x > 0 ifTrue:
				[ self should: [ (aMaHashIndexRecord highestSlotIndexFor: key-1) < x ] ].

			key := aMaHashIndexRecord highestKeyAtIndex: x.
			self should:
				[ x
					between: (aMaHashIndexRecord slotIndexFor: key)
					and: (aMaHashIndexRecord highestSlotIndexFor: key) ].

			x < (aMaHashIndexRecord numberOfSlots - 1) ifTrue:
				[ self should: [ (aMaHashIndexRecord slotIndexFor: key+1) > x ] ] ]! !

!MaHashIndexRecordTester methodsFor: 'private tests' stamp: 'cmm 7/1/2005 17:00'!
verifyRecord: aMaHashIndexRecord do: twoArgBlock

	self
		verifyConsecutiveContiguousKeyRangesOn: aMaHashIndexRecord;
		verifyEntryIndexAndRangeEndpointCongruenceOn: aMaHashIndexRecord.
	aMaHashIndexRecord
		byteArrayIndexesFrom: 0
		do:
			[ : eachBax |
			twoArgBlock value: aMaHashIndexRecord value: eachBax.
			(aMaHashIndexRecord highKey - aMaHashIndexRecord lowKey) > 1  "if not fully zoomed in"
				ifTrue:
					[ | x lowestKey highestKey |
					x := aMaHashIndexRecord slotIndexForBax: eachBax.
					lowestKey := aMaHashIndexRecord lowestKeyAtIndex: x.
					highestKey := aMaHashIndexRecord highestKeyAtIndex: x.
					self
						verifyRecord:
							(aMaHashIndexRecord independentCopy
								beZoomedInToward: (lowestKey to: highestKey) atRandom
								from: aMaHashIndexRecord)
						do: twoArgBlock ] ]! !

!MaHashIndexRecordTester methodsFor: 'private creation' stamp: 'cmm 7/1/2005 17:15'!
zoomedRecord: keySize recordSize: recordSize childSpace: anInteger

	| answer prior |
	answer :=
		MaHashIndexRecord
			keySize: keySize
			valueSize: 64
			numberOfSlots: recordSize.
	[ (answer highKey - answer lowKey) > anInteger ]
		whileTrue:
			[ prior := answer.
			answer := answer
				beZoomedInToward: (answer lowKey to: answer highKey) atRandom
				from: answer ].
	^ (answer highKey - answer lowKey) < 1000
		ifTrue: [ prior ]
		ifFalse: [ answer ]! !

TestCase subclass: #MaHashIndexTester
	instanceVariableNames: 'sortedKeys predictedSize index values nextValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma-Collections-Tests'!

!MaHashIndexTester class methodsFor: 'as yet unclassified' stamp: 'cmm 3/28/2010 12:44'!
degradationTest
	| hdx random |
	hdx := MaHashIndex 
		create: (MaAtomicFileStream fileNamed: '_testDegradation.hdx')
		keySize: 32
		valueSize: 48
		recordSize: 8.
	random := Random seed: 51969.
	100 timesRepeat: 
		[ Transcript
			cr ;
			show: hdx size ;
			show: ' --> ' ;
			show: 
				[ 10000 timesRepeat: 
					[ hdx 
						add: 1
						at: (random nextInt: 4294967295) ] ] durationToRun ]! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 4/28/2005 22:08'!
addKey: keyInteger

	| value |
	self index
		add: (value := self getNextValue)
		at: keyInteger.
	sortedKeys add: keyInteger.
	(values
		at: keyInteger
		ifAbsentPut: [ OrderedCollection new ])
			add: value.
	predictedSize := predictedSize + 1.
	^ value! !

!MaHashIndexTester methodsFor: 'private actions' stamp: ''!
addKeys: anArray

	^anArray collect: [ :each | self addKey: each ]
! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 4/28/2005 22:03'!
allValues

	^ values
		inject: OrderedCollection new
		into:
			[ : coll : each |
			coll
				addAll: each;
				yourself ]! !

!MaHashIndexTester methodsFor: 'overriding' stamp: 'cmm 2/11/2011 16:20'!
defaultTimeout
"Timeouts on tests, ain't it great?!!"
	^ 99 days asSeconds! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 4/28/2005 22:04'!
getNextValue

	^ nextValue := nextValue + 1! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 1/30/2002 12:48'!
index

	^index
! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 4/11/2005 10:58'!
indexFileNameForKeySize: keySize recordSize: recordSize

	^ self environmentDirectory fullNameFor: 'k', keySize printString, 'r', recordSize printString, '.', MaHashIndex suggestedFileExtension! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 11/30/2002 17:41'!
indexKeys

	^(self index
		upTo: sortedKeys size
		keysFrom: 0) copy! !

!MaHashIndexTester methodsFor: 'private accessing' stamp: 'cmm 12/29/2005 22:58'!
indexValues

	^ (self index
		upTo: sortedKeys size
		keysAndValuesFrom: self index lowestPossibleKey
		to: self index highestPossibleKey
		startingAt: 1) last copy! !

!MaHashIndexTester methodsFor: 'private initializing' stamp: 'cmm 4/28/2005 22:06'!
initialize

	super initialize.
	values := Dictionary new.
	sortedKeys := SortedCollection new.
	nextValue := 2 raisedTo: 17  "some arbitrary number"! !

!MaHashIndexTester methodsFor: 'accessing' stamp: 'cmm 8/30/2006 16:36'!
keyAndRecordSizesToTest

	^#(16 24 32 40 48 56 64 96 128 160 192 224 256) -> #(2 4 8 16 32 64 128)! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 9/10/2006 00:47'!
keySizes: keySizesArray withRecordSizes: recordSizesArray run: selectorSymbol

	keySizesArray do:
		[ : eachKeySize |
		recordSizesArray do:
			[ : eachRecordSize |
			{ self 
				newInMemoryHashIndexWithKeySize: eachKeySize
				recordSize: eachRecordSize.
			self
				newHashIndexWithKeySize: eachKeySize
				recordSize: eachRecordSize. }

				do:
					[ : eachIndex |
					index := eachIndex.
					self
						setUp ;
						run: selectorSymbol keySize: eachKeySize recordSize: eachRecordSize ;
						tearDown ] ] ]! !

!MaHashIndexTester methodsFor: 'private creation' stamp: 'cmm 3/20/2009 18:50'!
newHashIndexWithKeySize: keySize recordSize: recordSize
	| filename |
	self notify: 'creating ',
		(filename := self
			indexFileNameForKeySize: keySize
			recordSize: recordSize), '..'.
	self deleteFilesNamed: { filename }.
	^ MaHashIndex
		createNamed: filename
		keySize: keySize
		valueSize: 48 "MaObjectBuffer oidSize"
		recordSize: recordSize! !

!MaHashIndexTester methodsFor: 'private creation' stamp: 'cmm 3/20/2009 18:49'!
newInMemoryHashIndexWithKeySize: keySize recordSize: recordSize 
	self notify: 'creating in-memory with keySize: ' , keySize printString , ' recordSize: ' , recordSize printString , '.'.
	^ MaHashIndex 
		newWithKeySize: keySize
		valueSize: 48 "MaObjectBuffer oidSize"
		recordSize: recordSize	! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 7/26/2012 20:16'!
notify: aString
	Transcript cr; show: aString! !

!MaHashIndexTester methodsFor: 'private actions' stamp: ''!
removeKey: keyInteger

	^self
		removeKey: keyInteger
		at: 1
! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 4/28/2005 22:06'!
removeKey: keyInteger at: anInteger

	self index
		remove: ((values at: keyInteger) removeAt: anInteger)
		at: keyInteger.
	sortedKeys remove: keyInteger.
	(values at: keyInteger) isEmpty ifTrue: [ values removeKey: keyInteger ].
	predictedSize := predictedSize - 1
! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 11/28/2002 00:15'!
removeKeys: aCollection

	aCollection do: [ :each | self removeKey: each ]! !

!MaHashIndexTester methodsFor: 'private actions' stamp: 'cmm 8/19/2007 22:08'!
run: selectorSymbol keySize: keySize recordSize: recordSize 
	self notify: 
		(String streamContents: 
			[ : stream | 
			stream
				nextPutAll: 'keysize ' ;
				maPrint: keySize ;
				nextPutAll: ' record size ' ;
				maPrint: recordSize ;
				nextPutAll: ' completed in ' ;
				nextPutAll: [ self perform: selectorSymbol ] durationToRun printString ])! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 9/10/2006 21:19'!
runHeavyAddsAndRemoves
	| keys1 keys2 keysToRemove1 keysToRemove2 indexDef tempKeys1 tempKeys2 |
	keys1 := OrderedCollection new: 40000.
	keys2 := OrderedCollection new: 40000.
	indexDef :=
		(MaSearchStringIndex attribute: #yourself)
			keySize: index keySize ;
			beAscii ;
			yourself.
	Symbol allSymbolTablesDo:
		[ :e |
		2 atRandom even
			ifTrue: [ keys2 add: (indexDef indexHashFor: e) ]
			ifFalse: [ keys1 add: (indexDef indexHashFor: e) ] ].
	keysToRemove1 := OrderedCollection new.
	tempKeys1 := keys1 copy.  tempKeys2 := keys2 copy.
	keys1 size // 3 timesRepeat: [ keysToRemove1 add: (tempKeys1 remove: tempKeys1 atRandom) ].
	keysToRemove2 := OrderedCollection new.
	keys2 size // 3 timesRepeat: [ keysToRemove2 add: (tempKeys2 remove: tempKeys2 atRandom) ].
	self
		addKeys: keys1;
		removeKeys: keysToRemove1;
		addKeys: keys2;
		removeKeys: keysToRemove2;
		verifyIndex! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 4/18/2005 10:11'!
runInsertionOfEndpointKeys
	"This tests keys that fall at the endpoints of records.  It covers the lowest and highest keys."

	self
		verifyInsertionOfDuplicateKey: 0;
		verifyInsertionOfDuplicateKey: (2 raisedTo: index keySize) - 1.
	self verifyIndex! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 3/10/2004 01:09'!
runKeyInsertionIntoBroadRecords
	"A 'broad' record is one whose key range is greater than its
	numberOfEntries, thus it cannot hold duplicate keys.
	This test adds keys in an order that requires the index to
	re-sequence keys across multiple broad records."

	self
		addKeys: #(500 450 470 550 400);
		verifyIndex;
		removeKey: 450;
		verifyIndex;
		addKey: 471;
		verifyIndex.
	25 timesRepeat: [ self addKey: 470 ].
	self verifyIndex.
	25 timesRepeat: [ self addKey: 469 ].
	self verifyIndex.
	1
		to: 25
		do:
			[ :each |
			each even
				ifTrue:
					[ self
						removeKey: 469
						at: each // 2 ] ].
	self verifyIndex! !

!MaHashIndexTester methodsFor: 'private framework' stamp: 'cmm 5/25/2005 15:28'!
setUp

	predictedSize := 0.
	values := Dictionary new.
	sortedKeys := SortedCollection new.
	nextValue := 2 raisedTo: 17  "some arbitrary number"! !

!MaHashIndexTester methodsFor: 'private framework' stamp: 'cmm 4/16/2002 23:43'!
tearDown

	index ifNotNil: [ index close ]
! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 9/9/2006 18:46'!
testHeavyAddsAndRemoves
	self
		keySizes: self keyAndRecordSizesToTest key
		withRecordSizes: self keyAndRecordSizesToTest value
		run: #runHeavyAddsAndRemoves! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 12/5/2002 17:28'!
testInsertionOfEndpointKeys

	self
		keySizes: self keyAndRecordSizesToTest key
		withRecordSizes: self keyAndRecordSizesToTest value
		run: #runInsertionOfEndpointKeys! !

!MaHashIndexTester methodsFor: 'tests' stamp: 'cmm 12/5/2002 17:28'!
testKeyInsertionIntoBroadRecords

	self
		keySizes: self keyAndRecordSizesToTest key
		withRecordSizes: self keyAndRecordSizesToTest value
		run: #runKeyInsertionIntoBroadRecords! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 11/30/2002 19:19'!
verifyIndex

	self shouldnt: [ index hasAnomalies ].
	self
		verifySize;
		verifyKeys;
		verifyKeyValuePairs;
		verifyKeyQuantities;
		verifyIndexPositions! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 4/28/2005 22:03'!
verifyIndexPositions

	| allValues |

	allValues := self allValues.
	(self index
		upTo: allValues size
		keysAndValuesFromIndex: 1) last
			maConsistsOf: allValues! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 4/17/2005 22:07'!
verifyInsertionOfDuplicateKey: keyInteger
	"Test the insertion of a many of the same key, requiring the
	receivers index to zoom all the way into that key and getting
	into the inverted records."

	25 timesRepeat: [ self addKey: keyInteger ].
	self should:
		[ (self index
			upTo: 100
			at: keyInteger) last
				size = 25 ].
	275 timesRepeat: [ self addKey: keyInteger ].
	self should:
		[ (self index
			upTo: 350
			at: keyInteger) last
				size = 300 ]
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 4/28/2005 22:06'!
verifyKeyQuantities

	self should:
		[ sortedKeys allSatisfy: [ :each | (self index occurrencesOf: each) = (values at: each) size ] ].
	self should:
		[ self index size = (
			self index
				numberOfEntriesFrom: 0
				to: sortedKeys last) ]
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: 'cmm 4/28/2005 22:06'!
verifyKeyValuePairs

	self indexKeys
		with: self indexValues
		do: [ : eachKey : eachValue | self should: [ (values at: eachKey) includes: eachValue ] ]
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: ''!
verifyKeys

	self should: [ self indexKeys maMatchesElementsOf: sortedKeys ]
! !

!MaHashIndexTester methodsFor: 'private tests' stamp: ''!
verifySize

	^self should: [ self index size = predictedSize ]
! !
MaAutoWeakDictionary initialize!
MaDictionary initialize!
MaSpecialCollectionsPackageInfo initialize!
